/**
 */
package de.mdelab.mlsdm;

import org.eclipse.emf.common.util.EList;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Activity</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> An Activity models behavior by a set of
 * ActivityNodes that are connected by ActivityEdges. Semaphores can be added to
 * model concurrently executed behavior. An Activity can have input and output
 * parameters. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.Activity#getParameters <em>Parameters</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage#getActivity()
 * @model
 * @generated
 */
public interface Activity extends MLElementWithUUID, MLAnnotatedElement, MLNamedElement, ActivityNodeContainer
{
	/**
	 * Returns the value of the '<em><b>Parameters</b></em>' containment
	 * reference list. The list contents are of type
	 * {@link de.mdelab.mlsdm.ActivityParameter}. It is bidirectional and its
	 * opposite is '{@link de.mdelab.mlsdm.ActivityParameter#getActivity
	 * <em>Activity</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameters</em>' containment reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Parameters</em>' containment reference
	 *         list.
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivity_Parameters()
	 * @see de.mdelab.mlsdm.ActivityParameter#getActivity
	 * @model opposite="activity" containment="true" ordered="false"
	 * @generated
	 */
	EList<ActivityParameter> getParameters();

} // Activity
