/**
 */
package de.mdelab.mlsdm;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '
 * <em><b>Activity Edge Guard Enum</b></em>', and utility methods for working
 * with them. <!-- end-user-doc --> <!-- begin-model-doc --> Enumeration of the
 * guards that an ActivityEdge can have. <!-- end-model-doc -->
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityEdgeGuardEnum()
 * @model
 * @generated
 */
public enum ActivityEdgeGuardEnum implements Enumerator
{
	/**
	 * The '<em><b>NONE</b></em>' literal object. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #NONE_VALUE
	 * @generated
	 * @ordered
	 */
	NONE(0, "NONE", "NONE"),

	/**
	 * The '<em><b>FOR EACH</b></em>' literal object. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #FOR_EACH_VALUE
	 * @generated
	 * @ordered
	 */
	FOR_EACH(1, "FOR_EACH", "FOR_EACH"),

	/**
	 * The '<em><b>END</b></em>' literal object. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #END_VALUE
	 * @generated
	 * @ordered
	 */
	END(2, "END", "END"),

	/**
	 * The '<em><b>SUCCESS</b></em>' literal object. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #SUCCESS_VALUE
	 * @generated
	 * @ordered
	 */
	SUCCESS(3, "SUCCESS", "SUCCESS"),

	/**
	 * The '<em><b>FAILURE</b></em>' literal object. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #FAILURE_VALUE
	 * @generated
	 * @ordered
	 */
	FAILURE(4, "FAILURE", "FAILURE"),

	/**
	 * The '<em><b>BOOLEAN</b></em>' literal object. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #BOOLEAN_VALUE
	 * @generated
	 * @ordered
	 */
	BOOLEAN(5, "BOOLEAN", "BOOLEAN"),

	/**
	 * The '<em><b>ELSE</b></em>' literal object. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #ELSE_VALUE
	 * @generated
	 * @ordered
	 */
	ELSE(6, "ELSE", "ELSE");

	/**
	 * The '<em><b>NONE</b></em>' literal value. <!-- begin-user-doc --> <!--
	 * end-user-doc --> <!-- begin-model-doc --> No guard. <!-- end-model-doc
	 * -->
	 * 
	 * @see #NONE
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int							NONE_VALUE		= 0;

	/**
	 * The '<em><b>FOR EACH</b></em>' literal value. <!-- begin-user-doc -->
	 * <!-- end-user-doc --> <!-- begin-model-doc --> Only valid for StoryNodes
	 * with FOR_EACH semantics. This edge is traversed for each match of the
	 * StoryNode's StoryPattern. <!-- end-model-doc -->
	 * 
	 * @see #FOR_EACH
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int							FOR_EACH_VALUE	= 1;

	/**
	 * The '<em><b>END</b></em>' literal value. <!-- begin-user-doc --> <!--
	 * end-user-doc --> <!-- begin-model-doc --> Only valid for StoryNodes with
	 * FOR_EACH semantics. This edge is traversed when no more matches for the
	 * StoryNode's StoryPattern can be found. <!-- end-model-doc -->
	 * 
	 * @see #END
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int							END_VALUE		= 2;

	/**
	 * The '<em><b>SUCCESS</b></em>' literal value. <!-- begin-user-doc --> <!--
	 * end-user-doc --> <!-- begin-model-doc --> Only valid for StoryNodes with
	 * SINGLE_MATCH semantics. This edge is traversed when a match for the
	 * StoryNode's StoryPattern was found. <!-- end-model-doc -->
	 * 
	 * @see #SUCCESS
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int							SUCCESS_VALUE	= 3;

	/**
	 * The '<em><b>FAILURE</b></em>' literal value. <!-- begin-user-doc --> <!--
	 * end-user-doc --> <!-- begin-model-doc --> Only valid for StoryNodes with
	 * SINGLE_MATCH semantics. This edge is traversed when no match for the
	 * StoryNode's StoryPattern was found. <!-- end-model-doc -->
	 * 
	 * @see #FAILURE
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int							FAILURE_VALUE	= 4;

	/**
	 * The '<em><b>BOOLEAN</b></em>' literal value. <!-- begin-user-doc --> <!--
	 * end-user-doc --> <!-- begin-model-doc --> Only valid for
	 * DecisionMergeNodes. This edge is traversed when the edge's
	 * guardExpression is evaluated to true. <!-- end-model-doc -->
	 * 
	 * @see #BOOLEAN
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int							BOOLEAN_VALUE	= 5;

	/**
	 * The '<em><b>ELSE</b></em>' literal value. <!-- begin-user-doc --> <!--
	 * end-user-doc --> <!-- begin-model-doc --> Only valid for
	 * DecisionMergeNodes. This edge is traversed when the guardExpressions of
	 * all other edges of the DecisionMergeNode were evaluated to false. A
	 * DecisionMergeNode must have exactly one outgoing edge with guard ELSE.
	 * <!-- end-model-doc -->
	 * 
	 * @see #ELSE
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int							ELSE_VALUE		= 6;

	/**
	 * An array of all the '<em><b>Activity Edge Guard Enum</b></em>'
	 * enumerators. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private static final ActivityEdgeGuardEnum[]	VALUES_ARRAY	= new ActivityEdgeGuardEnum[]
																	{
			NONE, FOR_EACH, END, SUCCESS, FAILURE, BOOLEAN, ELSE,
																	};

	/**
	 * A public read-only list of all the '
	 * <em><b>Activity Edge Guard Enum</b></em>' enumerators. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final List<ActivityEdgeGuardEnum>	VALUES			= Collections.unmodifiableList(Arrays
																			.asList(ActivityEdgeGuardEnum.VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Activity Edge Guard Enum</b></em>' literal with the
	 * specified literal value. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ActivityEdgeGuardEnum get(final String literal)
	{
		for (int i = 0; i < ActivityEdgeGuardEnum.VALUES_ARRAY.length; ++i)
		{
			final ActivityEdgeGuardEnum result = ActivityEdgeGuardEnum.VALUES_ARRAY[i];
			if (result.toString().equals(literal))
			{
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Activity Edge Guard Enum</b></em>' literal with the
	 * specified name. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ActivityEdgeGuardEnum getByName(final String name)
	{
		for (int i = 0; i < ActivityEdgeGuardEnum.VALUES_ARRAY.length; ++i)
		{
			final ActivityEdgeGuardEnum result = ActivityEdgeGuardEnum.VALUES_ARRAY[i];
			if (result.getName().equals(name))
			{
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Activity Edge Guard Enum</b></em>' literal with the
	 * specified integer value. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ActivityEdgeGuardEnum get(final int value)
	{
		switch (value)
		{
			case NONE_VALUE:
				return NONE;
			case FOR_EACH_VALUE:
				return FOR_EACH;
			case END_VALUE:
				return END;
			case SUCCESS_VALUE:
				return SUCCESS;
			case FAILURE_VALUE:
				return FAILURE;
			case BOOLEAN_VALUE:
				return BOOLEAN;
			case ELSE_VALUE:
				return ELSE;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final int		value;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	name;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	literal;

	/**
	 * Only this class can construct instances. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	private ActivityEdgeGuardEnum(final int value, final String name, final String literal)
	{
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int getValue()
	{
		return this.value;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getName()
	{
		return this.name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getLiteral()
	{
		return this.literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string
	 * representation. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString()
	{
		return this.literal;
	}

} // ActivityEdgeGuardEnum
