/**
 */
package de.mdelab.mlsdm;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Activity Final Node</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> An ActivityFinalNode terminates the execution of an
 * activity and all its concurrent execution flows. The values of output
 * parameters are calculated using the outputParameterValues. <!-- end-model-doc
 * -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.ActivityFinalNode#getOutputParameterValues <em>
 * Output Parameter Values</em>}</li>
 * <li>{@link de.mdelab.mlsdm.ActivityFinalNode#getActivity <em>Activity</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityFinalNode()
 * @model
 * @generated
 */
public interface ActivityFinalNode extends ActivityNode
{
	/**
	 * Returns the value of the '<em><b>Output Parameter Values</b></em>'
	 * containment reference list. The list contents are of type
	 * {@link de.mdelab.mlsdm.OutputParameterValue}. It is bidirectional and its
	 * opposite is '
	 * {@link de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode
	 * <em>Activity Final Node</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Output Parameter Values</em>' containment
	 * reference list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Output Parameter Values</em>' containment
	 *         reference list.
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityFinalNode_OutputParameterValues()
	 * @see de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode
	 * @model opposite="activityFinalNode" containment="true" ordered="false"
	 * @generated
	 */
	EList<OutputParameterValue> getOutputParameterValues();

	/**
	 * Returns the value of the '<em><b>Activity</b></em>' reference. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activity</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Activity</em>' reference.
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityFinalNode_Activity()
	 * @model resolveProxies="false" required="true" transient="true"
	 *        changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	Activity getActivity();

} // ActivityFinalNode
