/**
 */
package de.mdelab.mlsdm;

import org.eclipse.emf.common.util.EList;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Activity Node</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> Superclass of all nodes that can be contained in an
 * Activity. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.ActivityNode#getOutgoingEdges <em>Outgoing Edges
 * </em>}</li>
 * <li>{@link de.mdelab.mlsdm.ActivityNode#getIncomingEdges <em>Incoming Edges
 * </em>}</li>
 * <li>{@link de.mdelab.mlsdm.ActivityNode#getActivityNodeContainer <em>Activity
 * Node Container</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityNode()
 * @model abstract="true"
 * @generated
 */
public interface ActivityNode extends MLElementWithUUID, MLAnnotatedElement
{
	/**
	 * Returns the value of the '<em><b>Outgoing Edges</b></em>' reference list.
	 * The list contents are of type {@link de.mdelab.mlsdm.ActivityEdge}. It is
	 * bidirectional and its opposite is '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getSource <em>Source</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outgoing Edges</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Outgoing Edges</em>' reference list.
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityNode_OutgoingEdges()
	 * @see de.mdelab.mlsdm.ActivityEdge#getSource
	 * @model opposite="source" ordered="false"
	 * @generated
	 */
	EList<ActivityEdge> getOutgoingEdges();

	/**
	 * Returns the value of the '<em><b>Incoming Edges</b></em>' reference list.
	 * The list contents are of type {@link de.mdelab.mlsdm.ActivityEdge}. It is
	 * bidirectional and its opposite is '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getTarget <em>Target</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Incoming Edges</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Incoming Edges</em>' reference list.
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityNode_IncomingEdges()
	 * @see de.mdelab.mlsdm.ActivityEdge#getTarget
	 * @model opposite="target" ordered="false"
	 * @generated
	 */
	EList<ActivityEdge> getIncomingEdges();

	/**
	 * Returns the value of the '<em><b>Activity Node Container</b></em>'
	 * container reference. It is bidirectional and its opposite is '
	 * {@link de.mdelab.mlsdm.ActivityNodeContainer#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activity Node Container</em>' container
	 * reference isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Activity Node Container</em>' container
	 *         reference.
	 * @see #setActivityNodeContainer(ActivityNodeContainer)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityNode_ActivityNodeContainer()
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getNodes
	 * @model opposite="nodes" resolveProxies="false" required="true"
	 *        transient="false"
	 * @generated
	 */
	ActivityNodeContainer getActivityNodeContainer();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlsdm.ActivityNode#getActivityNodeContainer
	 * <em>Activity Node Container</em>}' container reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Activity Node Container</em>'
	 *            container reference.
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	void setActivityNodeContainer(ActivityNodeContainer value);

} // ActivityNode
