/**
 */
package de.mdelab.mlsdm;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Activity Parameter</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> Specifies a parameter of an Activity. In and inout
 * parameters have to be provided before the exection of the Activity. Values
 * for the out and inout parameters are calculated when the Activity terminates.
 * <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.ActivityParameter#getDirection <em>Direction</em>}
 * </li>
 * <li>{@link de.mdelab.mlsdm.ActivityParameter#getActivity <em>Activity</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityParameter()
 * @model
 * @generated
 */
public interface ActivityParameter extends MLElementWithUUID, MLAnnotatedElement, MLNamedElement, MLTypedElement
{
	/**
	 * Returns the value of the '<em><b>Direction</b></em>' attribute. The
	 * default value is <code>"IN"</code>. The literals are from the enumeration
	 * {@link de.mdelab.mlsdm.ActivityParameterDirectionEnum}. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Direction</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Direction</em>' attribute.
	 * @see de.mdelab.mlsdm.ActivityParameterDirectionEnum
	 * @see #setDirection(ActivityParameterDirectionEnum)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityParameter_Direction()
	 * @model default="IN" required="true"
	 * @generated
	 */
	ActivityParameterDirectionEnum getDirection();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlsdm.ActivityParameter#getDirection <em>Direction</em>}
	 * ' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Direction</em>' attribute.
	 * @see de.mdelab.mlsdm.ActivityParameterDirectionEnum
	 * @see #getDirection()
	 * @generated
	 */
	void setDirection(ActivityParameterDirectionEnum value);

	/**
	 * Returns the value of the '<em><b>Activity</b></em>' container reference.
	 * It is bidirectional and its opposite is '
	 * {@link de.mdelab.mlsdm.Activity#getParameters <em>Parameters</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activity</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Activity</em>' container reference.
	 * @see #setActivity(Activity)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityParameter_Activity()
	 * @see de.mdelab.mlsdm.Activity#getParameters
	 * @model opposite="parameters" required="true" transient="false"
	 * @generated
	 */
	Activity getActivity();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlsdm.ActivityParameter#getActivity <em>Activity</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Activity</em>' container reference.
	 * @see #getActivity()
	 * @generated
	 */
	void setActivity(Activity value);

} // ActivityParameter
