/**
 */
package de.mdelab.mlsdm;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import de.mdelab.mlcore.MlcorePackage;

/**
 * <!-- begin-user-doc --> The <b>Package</b> for the model. It contains
 * accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each operation of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * 
 * @see de.mdelab.mlsdm.MlsdmFactory
 * @model kind="package"
 * @generated
 */
public interface MlsdmPackage extends EPackage
{
	/**
	 * The package name. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String			eNAME												= "mlsdm";

	/**
	 * The package namespace URI. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String			eNS_URI												= "http://www.mdelab.de/mlsdm/1.0";

	/**
	 * The package namespace name. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String			eNS_PREFIX											= "mlsdm";

	/**
	 * The singleton instance of the package. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	MlsdmPackage	eINSTANCE											= de.mdelab.mlsdm.impl.MlsdmPackageImpl.init();

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.impl.ActivityNodeContainerImpl
	 * <em>Activity Node Container</em>}' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ActivityNodeContainerImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityNodeContainer()
	 * @generated
	 */
	int				ACTIVITY_NODE_CONTAINER								= 0;

	/**
	 * The feature id for the '<em><b>Edges</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE_CONTAINER__EDGES						= 0;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE_CONTAINER__NODES						= 1;

	/**
	 * The feature id for the '<em><b>Semaphores</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE_CONTAINER__SEMAPHORES					= 2;

	/**
	 * The feature id for the '<em><b>Synchronization Edges</b></em>'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES		= 3;

	/**
	 * The number of structural features of the '
	 * <em>Activity Node Container</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE_CONTAINER_FEATURE_COUNT				= 4;

	/**
	 * The number of operations of the '<em>Activity Node Container</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE_CONTAINER_OPERATION_COUNT				= 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ActivityImpl
	 * <em>Activity</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ActivityImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivity()
	 * @generated
	 */
	int				ACTIVITY											= 1;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY__UUID										= MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY__ANNOTATIONS								= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY__NAME										= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Edges</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY__EDGES										= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY__NODES										= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Semaphores</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY__SEMAPHORES								= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Synchronization Edges</b></em>'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY__SYNCHRONIZATION_EDGES						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY__PARAMETERS								= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Activity</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FEATURE_COUNT								= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 7;

	/**
	 * The number of operations of the '<em>Activity</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_OPERATION_COUNT							= MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ActivityNodeImpl
	 * <em>Activity Node</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ActivityNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityNode()
	 * @generated
	 */
	int				ACTIVITY_NODE										= 2;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE__UUID									= MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE__ANNOTATIONS							= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE__OUTGOING_EDGES						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE__INCOMING_EDGES						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER				= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Activity Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE_FEATURE_COUNT							= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Activity Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_NODE_OPERATION_COUNT						= MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl
	 * <em>Activity Edge</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ActivityEdgeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityEdge()
	 * @generated
	 */
	int				ACTIVITY_EDGE										= 3;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__UUID									= MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__ANNOTATIONS							= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__SOURCE								= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__TARGET								= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER				= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Guard Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__GUARD_TYPE							= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Guard Expression</b></em>' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__GUARD_EXPRESSION						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Acquire Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__ACQUIRE_EDGES						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Release Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__RELEASE_EDGES						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Assertion Expressions</b></em>'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE__ASSERTION_EXPRESSIONS				= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>Activity Edge</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE_FEATURE_COUNT							= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 9;

	/**
	 * The number of operations of the '<em>Activity Edge</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_EDGE_OPERATION_COUNT						= MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.InitialNodeImpl
	 * <em>Initial Node</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.InitialNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getInitialNode()
	 * @generated
	 */
	int				INITIAL_NODE										= 4;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				INITIAL_NODE__UUID									= MlsdmPackage.ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				INITIAL_NODE__ANNOTATIONS							= MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				INITIAL_NODE__OUTGOING_EDGES						= MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				INITIAL_NODE__INCOMING_EDGES						= MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				INITIAL_NODE__ACTIVITY_NODE_CONTAINER				= MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The number of structural features of the '<em>Initial Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				INITIAL_NODE_FEATURE_COUNT							= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Initial Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				INITIAL_NODE_OPERATION_COUNT						= MlsdmPackage.ACTIVITY_NODE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.impl.FlowFinalNodeImpl <em>Flow Final Node</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.FlowFinalNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getFlowFinalNode()
	 * @generated
	 */
	int				FLOW_FINAL_NODE										= 5;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FLOW_FINAL_NODE__UUID								= MlsdmPackage.ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FLOW_FINAL_NODE__ANNOTATIONS						= MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FLOW_FINAL_NODE__OUTGOING_EDGES						= MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FLOW_FINAL_NODE__INCOMING_EDGES						= MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FLOW_FINAL_NODE__ACTIVITY_NODE_CONTAINER			= MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The number of structural features of the '<em>Flow Final Node</em>'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FLOW_FINAL_NODE_FEATURE_COUNT						= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Flow Final Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FLOW_FINAL_NODE_OPERATION_COUNT						= MlsdmPackage.ACTIVITY_NODE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.impl.ActivityFinalNodeImpl
	 * <em>Activity Final Node</em>}' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ActivityFinalNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityFinalNode()
	 * @generated
	 */
	int				ACTIVITY_FINAL_NODE									= 6;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FINAL_NODE__UUID							= MlsdmPackage.ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FINAL_NODE__ANNOTATIONS					= MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FINAL_NODE__OUTGOING_EDGES					= MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FINAL_NODE__INCOMING_EDGES					= MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FINAL_NODE__ACTIVITY_NODE_CONTAINER		= MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Output Parameter Values</b></em>'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES		= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Activity</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FINAL_NODE__ACTIVITY						= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Activity Final Node</em>'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FINAL_NODE_FEATURE_COUNT					= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Activity Final Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_FINAL_NODE_OPERATION_COUNT					= MlsdmPackage.ACTIVITY_NODE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl
	 * <em>Expression Activity Node</em>}' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getExpressionActivityNode()
	 * @generated
	 */
	int				EXPRESSION_ACTIVITY_NODE							= 7;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				EXPRESSION_ACTIVITY_NODE__UUID						= MlsdmPackage.ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				EXPRESSION_ACTIVITY_NODE__ANNOTATIONS				= MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				EXPRESSION_ACTIVITY_NODE__OUTGOING_EDGES			= MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				EXPRESSION_ACTIVITY_NODE__INCOMING_EDGES			= MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				EXPRESSION_ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER	= MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				EXPRESSION_ACTIVITY_NODE__NAME						= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expressions</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				EXPRESSION_ACTIVITY_NODE__EXPRESSIONS				= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '
	 * <em>Expression Activity Node</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				EXPRESSION_ACTIVITY_NODE_FEATURE_COUNT				= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Expression Activity Node</em>'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				EXPRESSION_ACTIVITY_NODE_OPERATION_COUNT			= MlsdmPackage.ACTIVITY_NODE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.impl.DecisionMergeNodeImpl
	 * <em>Decision Merge Node</em>}' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.DecisionMergeNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getDecisionMergeNode()
	 * @generated
	 */
	int				DECISION_MERGE_NODE									= 8;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				DECISION_MERGE_NODE__UUID							= MlsdmPackage.ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				DECISION_MERGE_NODE__ANNOTATIONS					= MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				DECISION_MERGE_NODE__OUTGOING_EDGES					= MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				DECISION_MERGE_NODE__INCOMING_EDGES					= MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				DECISION_MERGE_NODE__ACTIVITY_NODE_CONTAINER		= MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The number of structural features of the '<em>Decision Merge Node</em>'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				DECISION_MERGE_NODE_FEATURE_COUNT					= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Decision Merge Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				DECISION_MERGE_NODE_OPERATION_COUNT					= MlsdmPackage.ACTIVITY_NODE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ForkJoinNodeImpl
	 * <em>Fork Join Node</em>}' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ForkJoinNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getForkJoinNode()
	 * @generated
	 */
	int				FORK_JOIN_NODE										= 9;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FORK_JOIN_NODE__UUID								= MlsdmPackage.ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FORK_JOIN_NODE__ANNOTATIONS							= MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FORK_JOIN_NODE__OUTGOING_EDGES						= MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FORK_JOIN_NODE__INCOMING_EDGES						= MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FORK_JOIN_NODE__ACTIVITY_NODE_CONTAINER				= MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The number of structural features of the '<em>Fork Join Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FORK_JOIN_NODE_FEATURE_COUNT						= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Fork Join Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FORK_JOIN_NODE_OPERATION_COUNT						= MlsdmPackage.ACTIVITY_NODE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.StoryNodeImpl
	 * <em>Story Node</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.StoryNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStoryNode()
	 * @generated
	 */
	int				STORY_NODE											= 10;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE__UUID									= MlsdmPackage.ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE__ANNOTATIONS								= MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE__OUTGOING_EDGES							= MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE__INCOMING_EDGES							= MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE__ACTIVITY_NODE_CONTAINER					= MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE__NAME									= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE__STORY_PATTERN							= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Semantics</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE__SEMANTICS								= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Story Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE_FEATURE_COUNT							= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Story Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STORY_NODE_OPERATION_COUNT							= MlsdmPackage.ACTIVITY_NODE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.impl.StructuredNodeImpl <em>Structured Node</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.StructuredNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStructuredNode()
	 * @generated
	 */
	int				STRUCTURED_NODE										= 11;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE__UUID								= MlsdmPackage.ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE__ANNOTATIONS						= MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE__OUTGOING_EDGES						= MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE__INCOMING_EDGES						= MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE__ACTIVITY_NODE_CONTAINER			= MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Edges</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE__EDGES								= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE__NODES								= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Semaphores</b></em>' containment reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE__SEMAPHORES							= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Synchronization Edges</b></em>'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE__SYNCHRONIZATION_EDGES				= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Structured Node</em>'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE_FEATURE_COUNT						= MlsdmPackage.ACTIVITY_NODE_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Structured Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				STRUCTURED_NODE_OPERATION_COUNT						= MlsdmPackage.ACTIVITY_NODE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.SemaphoreImpl
	 * <em>Semaphore</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.SemaphoreImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getSemaphore()
	 * @generated
	 */
	int				SEMAPHORE											= 12;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SEMAPHORE__UUID										= MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SEMAPHORE__ANNOTATIONS								= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SEMAPHORE__NAME										= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SEMAPHORE__ACTIVITY_NODE_CONTAINER					= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Token Count</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SEMAPHORE__TOKEN_COUNT								= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Acquire Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SEMAPHORE__ACQUIRE_EDGES							= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Release Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SEMAPHORE__RELEASE_EDGES							= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Semaphore</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SEMAPHORE_FEATURE_COUNT								= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Semaphore</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SEMAPHORE_OPERATION_COUNT							= MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.impl.SynchronizationEdgeImpl
	 * <em>Synchronization Edge</em>}' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.SynchronizationEdgeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getSynchronizationEdge()
	 * @generated
	 */
	int				SYNCHRONIZATION_EDGE								= 13;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SYNCHRONIZATION_EDGE__UUID							= MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SYNCHRONIZATION_EDGE__ANNOTATIONS					= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER		= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Weight</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SYNCHRONIZATION_EDGE__WEIGHT						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Synchronization Edge</em>'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SYNCHRONIZATION_EDGE_FEATURE_COUNT					= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Synchronization Edge</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SYNCHRONIZATION_EDGE_OPERATION_COUNT				= MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.AcquireEdgeImpl
	 * <em>Acquire Edge</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.AcquireEdgeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getAcquireEdge()
	 * @generated
	 */
	int				ACQUIRE_EDGE										= 14;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACQUIRE_EDGE__UUID									= MlsdmPackage.SYNCHRONIZATION_EDGE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACQUIRE_EDGE__ANNOTATIONS							= MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACQUIRE_EDGE__ACTIVITY_NODE_CONTAINER				= MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Weight</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACQUIRE_EDGE__WEIGHT								= MlsdmPackage.SYNCHRONIZATION_EDGE__WEIGHT;

	/**
	 * The feature id for the '<em><b>Activity Edge</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACQUIRE_EDGE__ACTIVITY_EDGE							= MlsdmPackage.SYNCHRONIZATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Semaphore</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACQUIRE_EDGE__SEMAPHORE								= MlsdmPackage.SYNCHRONIZATION_EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Acquire Edge</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACQUIRE_EDGE_FEATURE_COUNT							= MlsdmPackage.SYNCHRONIZATION_EDGE_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Acquire Edge</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACQUIRE_EDGE_OPERATION_COUNT						= MlsdmPackage.SYNCHRONIZATION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ReleaseEdgeImpl
	 * <em>Release Edge</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ReleaseEdgeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getReleaseEdge()
	 * @generated
	 */
	int				RELEASE_EDGE										= 15;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				RELEASE_EDGE__UUID									= MlsdmPackage.SYNCHRONIZATION_EDGE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				RELEASE_EDGE__ANNOTATIONS							= MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				RELEASE_EDGE__ACTIVITY_NODE_CONTAINER				= MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Weight</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				RELEASE_EDGE__WEIGHT								= MlsdmPackage.SYNCHRONIZATION_EDGE__WEIGHT;

	/**
	 * The feature id for the '<em><b>Activity Edge</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				RELEASE_EDGE__ACTIVITY_EDGE							= MlsdmPackage.SYNCHRONIZATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Semaphore</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				RELEASE_EDGE__SEMAPHORE								= MlsdmPackage.SYNCHRONIZATION_EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Release Edge</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				RELEASE_EDGE_FEATURE_COUNT							= MlsdmPackage.SYNCHRONIZATION_EDGE_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Release Edge</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				RELEASE_EDGE_OPERATION_COUNT						= MlsdmPackage.SYNCHRONIZATION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.impl.ActivityParameterImpl
	 * <em>Activity Parameter</em>}' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ActivityParameterImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityParameter()
	 * @generated
	 */
	int				ACTIVITY_PARAMETER									= 16;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_PARAMETER__UUID							= MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_PARAMETER__ANNOTATIONS						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_PARAMETER__NAME							= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_PARAMETER__TYPE							= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_PARAMETER__DIRECTION						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Activity</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_PARAMETER__ACTIVITY						= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Activity Parameter</em>'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_PARAMETER_FEATURE_COUNT					= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Activity Parameter</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				ACTIVITY_PARAMETER_OPERATION_COUNT					= MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.impl.OutputParameterValueImpl
	 * <em>Output Parameter Value</em>}' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.impl.OutputParameterValueImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getOutputParameterValue()
	 * @generated
	 */
	int				OUTPUT_PARAMETER_VALUE								= 17;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				OUTPUT_PARAMETER_VALUE__UUID						= MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				OUTPUT_PARAMETER_VALUE__ANNOTATIONS					= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				OUTPUT_PARAMETER_VALUE__PARAMETER					= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				OUTPUT_PARAMETER_VALUE__EXPRESSION					= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Activity Final Node</b></em>' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE			= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Output Parameter Value</em>
	 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				OUTPUT_PARAMETER_VALUE_FEATURE_COUNT				= MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Output Parameter Value</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				OUTPUT_PARAMETER_VALUE_OPERATION_COUNT				= MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.ActivityEdgeGuardEnum
	 * <em>Activity Edge Guard Enum</em>}' enum. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.ActivityEdgeGuardEnum
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityEdgeGuardEnum()
	 * @generated
	 */
	int				ACTIVITY_EDGE_GUARD_ENUM							= 18;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.StoryNodeSemanticsEnum
	 * <em>Story Node Semantics Enum</em>}' enum. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.StoryNodeSemanticsEnum
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStoryNodeSemanticsEnum()
	 * @generated
	 */
	int				STORY_NODE_SEMANTICS_ENUM							= 19;

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlsdm.ActivityParameterDirectionEnum
	 * <em>Activity Parameter Direction Enum</em>}' enum. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see de.mdelab.mlsdm.ActivityParameterDirectionEnum
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityParameterDirectionEnum()
	 * @generated
	 */
	int				ACTIVITY_PARAMETER_DIRECTION_ENUM					= 20;

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlsdm.ActivityNodeContainer
	 * <em>Activity Node Container</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer
	 * @generated
	 */
	EClass getActivityNodeContainer();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlsdm.ActivityNodeContainer#getEdges <em>Edges</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getEdges()
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	EReference getActivityNodeContainer_Edges();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlsdm.ActivityNodeContainer#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Nodes</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getNodes()
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	EReference getActivityNodeContainer_Nodes();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlsdm.ActivityNodeContainer#getSemaphores
	 * <em>Semaphores</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Semaphores</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getSemaphores()
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	EReference getActivityNodeContainer_Semaphores();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlsdm.ActivityNodeContainer#getSynchronizationEdges
	 * <em>Synchronization Edges</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Synchronization Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getSynchronizationEdges()
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	EReference getActivityNodeContainer_SynchronizationEdges();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.Activity
	 * <em>Activity</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity</em>'.
	 * @see de.mdelab.mlsdm.Activity
	 * @generated
	 */
	EClass getActivity();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlsdm.Activity#getParameters <em>Parameters</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Parameters</em>'.
	 * @see de.mdelab.mlsdm.Activity#getParameters()
	 * @see #getActivity()
	 * @generated
	 */
	EReference getActivity_Parameters();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ActivityNode
	 * <em>Activity Node</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Node</em>'.
	 * @see de.mdelab.mlsdm.ActivityNode
	 * @generated
	 */
	EClass getActivityNode();

	/**
	 * Returns the meta object for the reference list '
	 * {@link de.mdelab.mlsdm.ActivityNode#getOutgoingEdges
	 * <em>Outgoing Edges</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Outgoing Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityNode#getOutgoingEdges()
	 * @see #getActivityNode()
	 * @generated
	 */
	EReference getActivityNode_OutgoingEdges();

	/**
	 * Returns the meta object for the reference list '
	 * {@link de.mdelab.mlsdm.ActivityNode#getIncomingEdges
	 * <em>Incoming Edges</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Incoming Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityNode#getIncomingEdges()
	 * @see #getActivityNode()
	 * @generated
	 */
	EReference getActivityNode_IncomingEdges();

	/**
	 * Returns the meta object for the container reference '
	 * {@link de.mdelab.mlsdm.ActivityNode#getActivityNodeContainer
	 * <em>Activity Node Container</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the container reference '
	 *         <em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.ActivityNode#getActivityNodeContainer()
	 * @see #getActivityNode()
	 * @generated
	 */
	EReference getActivityNode_ActivityNodeContainer();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ActivityEdge
	 * <em>Activity Edge</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Edge</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge
	 * @generated
	 */
	EClass getActivityEdge();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getSource <em>Source</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getSource()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_Source();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getTarget <em>Target</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getTarget()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_Target();

	/**
	 * Returns the meta object for the container reference '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getActivityNodeContainer
	 * <em>Activity Node Container</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the container reference '
	 *         <em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getActivityNodeContainer()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_ActivityNodeContainer();

	/**
	 * Returns the meta object for the attribute '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getGuardType <em>Guard Type</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Guard Type</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getGuardType()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EAttribute getActivityEdge_GuardType();

	/**
	 * Returns the meta object for the containment reference '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getGuardExpression
	 * <em>Guard Expression</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the containment reference '
	 *         <em>Guard Expression</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getGuardExpression()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_GuardExpression();

	/**
	 * Returns the meta object for the reference list '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getAcquireEdges
	 * <em>Acquire Edges</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Acquire Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getAcquireEdges()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_AcquireEdges();

	/**
	 * Returns the meta object for the reference list '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getReleaseEdges
	 * <em>Release Edges</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Release Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getReleaseEdges()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_ReleaseEdges();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getAssertionExpressions
	 * <em>Assertion Expressions</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Assertion Expressions</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getAssertionExpressions()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_AssertionExpressions();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.InitialNode
	 * <em>Initial Node</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Initial Node</em>'.
	 * @see de.mdelab.mlsdm.InitialNode
	 * @generated
	 */
	EClass getInitialNode();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.FlowFinalNode
	 * <em>Flow Final Node</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Flow Final Node</em>'.
	 * @see de.mdelab.mlsdm.FlowFinalNode
	 * @generated
	 */
	EClass getFlowFinalNode();

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlsdm.ActivityFinalNode <em>Activity Final Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Final Node</em>'.
	 * @see de.mdelab.mlsdm.ActivityFinalNode
	 * @generated
	 */
	EClass getActivityFinalNode();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlsdm.ActivityFinalNode#getOutputParameterValues
	 * <em>Output Parameter Values</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Output Parameter Values</em>'.
	 * @see de.mdelab.mlsdm.ActivityFinalNode#getOutputParameterValues()
	 * @see #getActivityFinalNode()
	 * @generated
	 */
	EReference getActivityFinalNode_OutputParameterValues();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.ActivityFinalNode#getActivity <em>Activity</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Activity</em>'.
	 * @see de.mdelab.mlsdm.ActivityFinalNode#getActivity()
	 * @see #getActivityFinalNode()
	 * @generated
	 */
	EReference getActivityFinalNode_Activity();

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlsdm.ExpressionActivityNode
	 * <em>Expression Activity Node</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Expression Activity Node</em>'.
	 * @see de.mdelab.mlsdm.ExpressionActivityNode
	 * @generated
	 */
	EClass getExpressionActivityNode();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlsdm.ExpressionActivityNode#getExpressions
	 * <em>Expressions</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Expressions</em>'.
	 * @see de.mdelab.mlsdm.ExpressionActivityNode#getExpressions()
	 * @see #getExpressionActivityNode()
	 * @generated
	 */
	EReference getExpressionActivityNode_Expressions();

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlsdm.DecisionMergeNode <em>Decision Merge Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Decision Merge Node</em>'.
	 * @see de.mdelab.mlsdm.DecisionMergeNode
	 * @generated
	 */
	EClass getDecisionMergeNode();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ForkJoinNode
	 * <em>Fork Join Node</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Fork Join Node</em>'.
	 * @see de.mdelab.mlsdm.ForkJoinNode
	 * @generated
	 */
	EClass getForkJoinNode();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.StoryNode
	 * <em>Story Node</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Story Node</em>'.
	 * @see de.mdelab.mlsdm.StoryNode
	 * @generated
	 */
	EClass getStoryNode();

	/**
	 * Returns the meta object for the containment reference '
	 * {@link de.mdelab.mlsdm.StoryNode#getStoryPattern <em>Story Pattern</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '
	 *         <em>Story Pattern</em>'.
	 * @see de.mdelab.mlsdm.StoryNode#getStoryPattern()
	 * @see #getStoryNode()
	 * @generated
	 */
	EReference getStoryNode_StoryPattern();

	/**
	 * Returns the meta object for the attribute '
	 * {@link de.mdelab.mlsdm.StoryNode#getSemantics <em>Semantics</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Semantics</em>'.
	 * @see de.mdelab.mlsdm.StoryNode#getSemantics()
	 * @see #getStoryNode()
	 * @generated
	 */
	EAttribute getStoryNode_Semantics();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.StructuredNode
	 * <em>Structured Node</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Structured Node</em>'.
	 * @see de.mdelab.mlsdm.StructuredNode
	 * @generated
	 */
	EClass getStructuredNode();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.Semaphore
	 * <em>Semaphore</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Semaphore</em>'.
	 * @see de.mdelab.mlsdm.Semaphore
	 * @generated
	 */
	EClass getSemaphore();

	/**
	 * Returns the meta object for the container reference '
	 * {@link de.mdelab.mlsdm.Semaphore#getActivityNodeContainer
	 * <em>Activity Node Container</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the container reference '
	 *         <em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.Semaphore#getActivityNodeContainer()
	 * @see #getSemaphore()
	 * @generated
	 */
	EReference getSemaphore_ActivityNodeContainer();

	/**
	 * Returns the meta object for the attribute '
	 * {@link de.mdelab.mlsdm.Semaphore#getTokenCount <em>Token Count</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Token Count</em>'.
	 * @see de.mdelab.mlsdm.Semaphore#getTokenCount()
	 * @see #getSemaphore()
	 * @generated
	 */
	EAttribute getSemaphore_TokenCount();

	/**
	 * Returns the meta object for the reference list '
	 * {@link de.mdelab.mlsdm.Semaphore#getAcquireEdges <em>Acquire Edges</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Acquire Edges</em>'.
	 * @see de.mdelab.mlsdm.Semaphore#getAcquireEdges()
	 * @see #getSemaphore()
	 * @generated
	 */
	EReference getSemaphore_AcquireEdges();

	/**
	 * Returns the meta object for the reference list '
	 * {@link de.mdelab.mlsdm.Semaphore#getReleaseEdges <em>Release Edges</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Release Edges</em>'.
	 * @see de.mdelab.mlsdm.Semaphore#getReleaseEdges()
	 * @see #getSemaphore()
	 * @generated
	 */
	EReference getSemaphore_ReleaseEdges();

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlsdm.SynchronizationEdge <em>Synchronization Edge</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Synchronization Edge</em>'.
	 * @see de.mdelab.mlsdm.SynchronizationEdge
	 * @generated
	 */
	EClass getSynchronizationEdge();

	/**
	 * Returns the meta object for the container reference '
	 * {@link de.mdelab.mlsdm.SynchronizationEdge#getActivityNodeContainer
	 * <em>Activity Node Container</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the container reference '
	 *         <em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.SynchronizationEdge#getActivityNodeContainer()
	 * @see #getSynchronizationEdge()
	 * @generated
	 */
	EReference getSynchronizationEdge_ActivityNodeContainer();

	/**
	 * Returns the meta object for the attribute '
	 * {@link de.mdelab.mlsdm.SynchronizationEdge#getWeight <em>Weight</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Weight</em>'.
	 * @see de.mdelab.mlsdm.SynchronizationEdge#getWeight()
	 * @see #getSynchronizationEdge()
	 * @generated
	 */
	EAttribute getSynchronizationEdge_Weight();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.AcquireEdge
	 * <em>Acquire Edge</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Acquire Edge</em>'.
	 * @see de.mdelab.mlsdm.AcquireEdge
	 * @generated
	 */
	EClass getAcquireEdge();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.AcquireEdge#getActivityEdge
	 * <em>Activity Edge</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Activity Edge</em>'.
	 * @see de.mdelab.mlsdm.AcquireEdge#getActivityEdge()
	 * @see #getAcquireEdge()
	 * @generated
	 */
	EReference getAcquireEdge_ActivityEdge();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.AcquireEdge#getSemaphore <em>Semaphore</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Semaphore</em>'.
	 * @see de.mdelab.mlsdm.AcquireEdge#getSemaphore()
	 * @see #getAcquireEdge()
	 * @generated
	 */
	EReference getAcquireEdge_Semaphore();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ReleaseEdge
	 * <em>Release Edge</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Release Edge</em>'.
	 * @see de.mdelab.mlsdm.ReleaseEdge
	 * @generated
	 */
	EClass getReleaseEdge();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.ReleaseEdge#getActivityEdge
	 * <em>Activity Edge</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Activity Edge</em>'.
	 * @see de.mdelab.mlsdm.ReleaseEdge#getActivityEdge()
	 * @see #getReleaseEdge()
	 * @generated
	 */
	EReference getReleaseEdge_ActivityEdge();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.ReleaseEdge#getSemaphore <em>Semaphore</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Semaphore</em>'.
	 * @see de.mdelab.mlsdm.ReleaseEdge#getSemaphore()
	 * @see #getReleaseEdge()
	 * @generated
	 */
	EReference getReleaseEdge_Semaphore();

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlsdm.ActivityParameter <em>Activity Parameter</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Parameter</em>'.
	 * @see de.mdelab.mlsdm.ActivityParameter
	 * @generated
	 */
	EClass getActivityParameter();

	/**
	 * Returns the meta object for the attribute '
	 * {@link de.mdelab.mlsdm.ActivityParameter#getDirection <em>Direction</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see de.mdelab.mlsdm.ActivityParameter#getDirection()
	 * @see #getActivityParameter()
	 * @generated
	 */
	EAttribute getActivityParameter_Direction();

	/**
	 * Returns the meta object for the container reference '
	 * {@link de.mdelab.mlsdm.ActivityParameter#getActivity <em>Activity</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Activity</em>'.
	 * @see de.mdelab.mlsdm.ActivityParameter#getActivity()
	 * @see #getActivityParameter()
	 * @generated
	 */
	EReference getActivityParameter_Activity();

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlsdm.OutputParameterValue
	 * <em>Output Parameter Value</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Output Parameter Value</em>'.
	 * @see de.mdelab.mlsdm.OutputParameterValue
	 * @generated
	 */
	EClass getOutputParameterValue();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.OutputParameterValue#getParameter
	 * <em>Parameter</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Parameter</em>'.
	 * @see de.mdelab.mlsdm.OutputParameterValue#getParameter()
	 * @see #getOutputParameterValue()
	 * @generated
	 */
	EReference getOutputParameterValue_Parameter();

	/**
	 * Returns the meta object for the containment reference '
	 * {@link de.mdelab.mlsdm.OutputParameterValue#getExpression
	 * <em>Expression</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '
	 *         <em>Expression</em>'.
	 * @see de.mdelab.mlsdm.OutputParameterValue#getExpression()
	 * @see #getOutputParameterValue()
	 * @generated
	 */
	EReference getOutputParameterValue_Expression();

	/**
	 * Returns the meta object for the container reference '
	 * {@link de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode
	 * <em>Activity Final Node</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the container reference '
	 *         <em>Activity Final Node</em>'.
	 * @see de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode()
	 * @see #getOutputParameterValue()
	 * @generated
	 */
	EReference getOutputParameterValue_ActivityFinalNode();

	/**
	 * Returns the meta object for enum '
	 * {@link de.mdelab.mlsdm.ActivityEdgeGuardEnum
	 * <em>Activity Edge Guard Enum</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Activity Edge Guard Enum</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdgeGuardEnum
	 * @generated
	 */
	EEnum getActivityEdgeGuardEnum();

	/**
	 * Returns the meta object for enum '
	 * {@link de.mdelab.mlsdm.StoryNodeSemanticsEnum
	 * <em>Story Node Semantics Enum</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Story Node Semantics Enum</em>'.
	 * @see de.mdelab.mlsdm.StoryNodeSemanticsEnum
	 * @generated
	 */
	EEnum getStoryNodeSemanticsEnum();

	/**
	 * Returns the meta object for enum '
	 * {@link de.mdelab.mlsdm.ActivityParameterDirectionEnum
	 * <em>Activity Parameter Direction Enum</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '
	 *         <em>Activity Parameter Direction Enum</em>'.
	 * @see de.mdelab.mlsdm.ActivityParameterDirectionEnum
	 * @generated
	 */
	EEnum getActivityParameterDirectionEnum();

	/**
	 * Returns the factory that creates the instances of the model. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MlsdmFactory getMlsdmFactory();

	/**
	 * <!-- begin-user-doc --> Defines literals for the meta objects that
	 * represent
	 * <ul>
	 * <li>each class,</li>
	 * <li>each feature of each class,</li>
	 * <li>each operation of each class,</li>
	 * <li>each enum,</li>
	 * <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	interface Literals
	{
		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.ActivityNodeContainerImpl
		 * <em>Activity Node Container</em>}' class. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.ActivityNodeContainerImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityNodeContainer()
		 * @generated
		 */
		EClass		ACTIVITY_NODE_CONTAINER							= MlsdmPackage.eINSTANCE.getActivityNodeContainer();

		/**
		 * The meta object literal for the '<em><b>Edges</b></em>' containment
		 * reference list feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_NODE_CONTAINER__EDGES					= MlsdmPackage.eINSTANCE.getActivityNodeContainer_Edges();

		/**
		 * The meta object literal for the '<em><b>Nodes</b></em>' containment
		 * reference list feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_NODE_CONTAINER__NODES					= MlsdmPackage.eINSTANCE.getActivityNodeContainer_Nodes();

		/**
		 * The meta object literal for the '<em><b>Semaphores</b></em>'
		 * containment reference list feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_NODE_CONTAINER__SEMAPHORES				= MlsdmPackage.eINSTANCE.getActivityNodeContainer_Semaphores();

		/**
		 * The meta object literal for the '
		 * <em><b>Synchronization Edges</b></em>' containment reference list
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES	= MlsdmPackage.eINSTANCE
																			.getActivityNodeContainer_SynchronizationEdges();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.ActivityImpl <em>Activity</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.ActivityImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivity()
		 * @generated
		 */
		EClass		ACTIVITY										= MlsdmPackage.eINSTANCE.getActivity();

		/**
		 * The meta object literal for the '<em><b>Parameters</b></em>'
		 * containment reference list feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY__PARAMETERS							= MlsdmPackage.eINSTANCE.getActivity_Parameters();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.ActivityNodeImpl <em>Activity Node</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.ActivityNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityNode()
		 * @generated
		 */
		EClass		ACTIVITY_NODE									= MlsdmPackage.eINSTANCE.getActivityNode();

		/**
		 * The meta object literal for the '<em><b>Outgoing Edges</b></em>'
		 * reference list feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_NODE__OUTGOING_EDGES					= MlsdmPackage.eINSTANCE.getActivityNode_OutgoingEdges();

		/**
		 * The meta object literal for the '<em><b>Incoming Edges</b></em>'
		 * reference list feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_NODE__INCOMING_EDGES					= MlsdmPackage.eINSTANCE.getActivityNode_IncomingEdges();

		/**
		 * The meta object literal for the '
		 * <em><b>Activity Node Container</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER			= MlsdmPackage.eINSTANCE.getActivityNode_ActivityNodeContainer();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.ActivityEdgeImpl <em>Activity Edge</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.ActivityEdgeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityEdge()
		 * @generated
		 */
		EClass		ACTIVITY_EDGE									= MlsdmPackage.eINSTANCE.getActivityEdge();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_EDGE__SOURCE							= MlsdmPackage.eINSTANCE.getActivityEdge_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_EDGE__TARGET							= MlsdmPackage.eINSTANCE.getActivityEdge_Target();

		/**
		 * The meta object literal for the '
		 * <em><b>Activity Node Container</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER			= MlsdmPackage.eINSTANCE.getActivityEdge_ActivityNodeContainer();

		/**
		 * The meta object literal for the '<em><b>Guard Type</b></em>'
		 * attribute feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	ACTIVITY_EDGE__GUARD_TYPE						= MlsdmPackage.eINSTANCE.getActivityEdge_GuardType();

		/**
		 * The meta object literal for the '<em><b>Guard Expression</b></em>'
		 * containment reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_EDGE__GUARD_EXPRESSION					= MlsdmPackage.eINSTANCE.getActivityEdge_GuardExpression();

		/**
		 * The meta object literal for the '<em><b>Acquire Edges</b></em>'
		 * reference list feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_EDGE__ACQUIRE_EDGES					= MlsdmPackage.eINSTANCE.getActivityEdge_AcquireEdges();

		/**
		 * The meta object literal for the '<em><b>Release Edges</b></em>'
		 * reference list feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_EDGE__RELEASE_EDGES					= MlsdmPackage.eINSTANCE.getActivityEdge_ReleaseEdges();

		/**
		 * The meta object literal for the '
		 * <em><b>Assertion Expressions</b></em>' containment reference list
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_EDGE__ASSERTION_EXPRESSIONS			= MlsdmPackage.eINSTANCE.getActivityEdge_AssertionExpressions();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.InitialNodeImpl <em>Initial Node</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.InitialNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getInitialNode()
		 * @generated
		 */
		EClass		INITIAL_NODE									= MlsdmPackage.eINSTANCE.getInitialNode();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.FlowFinalNodeImpl
		 * <em>Flow Final Node</em>}' class. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.FlowFinalNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getFlowFinalNode()
		 * @generated
		 */
		EClass		FLOW_FINAL_NODE									= MlsdmPackage.eINSTANCE.getFlowFinalNode();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.ActivityFinalNodeImpl
		 * <em>Activity Final Node</em>}' class. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.ActivityFinalNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityFinalNode()
		 * @generated
		 */
		EClass		ACTIVITY_FINAL_NODE								= MlsdmPackage.eINSTANCE.getActivityFinalNode();

		/**
		 * The meta object literal for the '
		 * <em><b>Output Parameter Values</b></em>' containment reference list
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES	= MlsdmPackage.eINSTANCE.getActivityFinalNode_OutputParameterValues();

		/**
		 * The meta object literal for the '<em><b>Activity</b></em>' reference
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_FINAL_NODE__ACTIVITY					= MlsdmPackage.eINSTANCE.getActivityFinalNode_Activity();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl
		 * <em>Expression Activity Node</em>}' class. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getExpressionActivityNode()
		 * @generated
		 */
		EClass		EXPRESSION_ACTIVITY_NODE						= MlsdmPackage.eINSTANCE.getExpressionActivityNode();

		/**
		 * The meta object literal for the '<em><b>Expressions</b></em>'
		 * containment reference list feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	EXPRESSION_ACTIVITY_NODE__EXPRESSIONS			= MlsdmPackage.eINSTANCE.getExpressionActivityNode_Expressions();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.DecisionMergeNodeImpl
		 * <em>Decision Merge Node</em>}' class. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.DecisionMergeNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getDecisionMergeNode()
		 * @generated
		 */
		EClass		DECISION_MERGE_NODE								= MlsdmPackage.eINSTANCE.getDecisionMergeNode();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.ForkJoinNodeImpl <em>Fork Join Node</em>}
		 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.ForkJoinNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getForkJoinNode()
		 * @generated
		 */
		EClass		FORK_JOIN_NODE									= MlsdmPackage.eINSTANCE.getForkJoinNode();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.StoryNodeImpl <em>Story Node</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.StoryNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStoryNode()
		 * @generated
		 */
		EClass		STORY_NODE										= MlsdmPackage.eINSTANCE.getStoryNode();

		/**
		 * The meta object literal for the '<em><b>Story Pattern</b></em>'
		 * containment reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	STORY_NODE__STORY_PATTERN						= MlsdmPackage.eINSTANCE.getStoryNode_StoryPattern();

		/**
		 * The meta object literal for the '<em><b>Semantics</b></em>' attribute
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	STORY_NODE__SEMANTICS							= MlsdmPackage.eINSTANCE.getStoryNode_Semantics();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.StructuredNodeImpl
		 * <em>Structured Node</em>}' class. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.StructuredNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStructuredNode()
		 * @generated
		 */
		EClass		STRUCTURED_NODE									= MlsdmPackage.eINSTANCE.getStructuredNode();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.SemaphoreImpl <em>Semaphore</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.SemaphoreImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getSemaphore()
		 * @generated
		 */
		EClass		SEMAPHORE										= MlsdmPackage.eINSTANCE.getSemaphore();

		/**
		 * The meta object literal for the '
		 * <em><b>Activity Node Container</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SEMAPHORE__ACTIVITY_NODE_CONTAINER				= MlsdmPackage.eINSTANCE.getSemaphore_ActivityNodeContainer();

		/**
		 * The meta object literal for the '<em><b>Token Count</b></em>'
		 * attribute feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SEMAPHORE__TOKEN_COUNT							= MlsdmPackage.eINSTANCE.getSemaphore_TokenCount();

		/**
		 * The meta object literal for the '<em><b>Acquire Edges</b></em>'
		 * reference list feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SEMAPHORE__ACQUIRE_EDGES						= MlsdmPackage.eINSTANCE.getSemaphore_AcquireEdges();

		/**
		 * The meta object literal for the '<em><b>Release Edges</b></em>'
		 * reference list feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SEMAPHORE__RELEASE_EDGES						= MlsdmPackage.eINSTANCE.getSemaphore_ReleaseEdges();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.SynchronizationEdgeImpl
		 * <em>Synchronization Edge</em>}' class. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.SynchronizationEdgeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getSynchronizationEdge()
		 * @generated
		 */
		EClass		SYNCHRONIZATION_EDGE							= MlsdmPackage.eINSTANCE.getSynchronizationEdge();

		/**
		 * The meta object literal for the '
		 * <em><b>Activity Node Container</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER	= MlsdmPackage.eINSTANCE.getSynchronizationEdge_ActivityNodeContainer();

		/**
		 * The meta object literal for the '<em><b>Weight</b></em>' attribute
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SYNCHRONIZATION_EDGE__WEIGHT					= MlsdmPackage.eINSTANCE.getSynchronizationEdge_Weight();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.AcquireEdgeImpl <em>Acquire Edge</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.AcquireEdgeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getAcquireEdge()
		 * @generated
		 */
		EClass		ACQUIRE_EDGE									= MlsdmPackage.eINSTANCE.getAcquireEdge();

		/**
		 * The meta object literal for the '<em><b>Activity Edge</b></em>'
		 * reference feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACQUIRE_EDGE__ACTIVITY_EDGE						= MlsdmPackage.eINSTANCE.getAcquireEdge_ActivityEdge();

		/**
		 * The meta object literal for the '<em><b>Semaphore</b></em>' reference
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACQUIRE_EDGE__SEMAPHORE							= MlsdmPackage.eINSTANCE.getAcquireEdge_Semaphore();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.ReleaseEdgeImpl <em>Release Edge</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.ReleaseEdgeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getReleaseEdge()
		 * @generated
		 */
		EClass		RELEASE_EDGE									= MlsdmPackage.eINSTANCE.getReleaseEdge();

		/**
		 * The meta object literal for the '<em><b>Activity Edge</b></em>'
		 * reference feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	RELEASE_EDGE__ACTIVITY_EDGE						= MlsdmPackage.eINSTANCE.getReleaseEdge_ActivityEdge();

		/**
		 * The meta object literal for the '<em><b>Semaphore</b></em>' reference
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	RELEASE_EDGE__SEMAPHORE							= MlsdmPackage.eINSTANCE.getReleaseEdge_Semaphore();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.ActivityParameterImpl
		 * <em>Activity Parameter</em>}' class. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.ActivityParameterImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityParameter()
		 * @generated
		 */
		EClass		ACTIVITY_PARAMETER								= MlsdmPackage.eINSTANCE.getActivityParameter();

		/**
		 * The meta object literal for the '<em><b>Direction</b></em>' attribute
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	ACTIVITY_PARAMETER__DIRECTION					= MlsdmPackage.eINSTANCE.getActivityParameter_Direction();

		/**
		 * The meta object literal for the '<em><b>Activity</b></em>' container
		 * reference feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ACTIVITY_PARAMETER__ACTIVITY					= MlsdmPackage.eINSTANCE.getActivityParameter_Activity();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.impl.OutputParameterValueImpl
		 * <em>Output Parameter Value</em>}' class. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.impl.OutputParameterValueImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getOutputParameterValue()
		 * @generated
		 */
		EClass		OUTPUT_PARAMETER_VALUE							= MlsdmPackage.eINSTANCE.getOutputParameterValue();

		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' reference
		 * feature. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	OUTPUT_PARAMETER_VALUE__PARAMETER				= MlsdmPackage.eINSTANCE.getOutputParameterValue_Parameter();

		/**
		 * The meta object literal for the '<em><b>Expression</b></em>'
		 * containment reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	OUTPUT_PARAMETER_VALUE__EXPRESSION				= MlsdmPackage.eINSTANCE.getOutputParameterValue_Expression();

		/**
		 * The meta object literal for the '<em><b>Activity Final Node</b></em>'
		 * container reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE		= MlsdmPackage.eINSTANCE.getOutputParameterValue_ActivityFinalNode();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.ActivityEdgeGuardEnum
		 * <em>Activity Edge Guard Enum</em>}' enum. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.ActivityEdgeGuardEnum
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityEdgeGuardEnum()
		 * @generated
		 */
		EEnum		ACTIVITY_EDGE_GUARD_ENUM						= MlsdmPackage.eINSTANCE.getActivityEdgeGuardEnum();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.StoryNodeSemanticsEnum
		 * <em>Story Node Semantics Enum</em>}' enum. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.StoryNodeSemanticsEnum
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStoryNodeSemanticsEnum()
		 * @generated
		 */
		EEnum		STORY_NODE_SEMANTICS_ENUM						= MlsdmPackage.eINSTANCE.getStoryNodeSemanticsEnum();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.ActivityParameterDirectionEnum
		 * <em>Activity Parameter Direction Enum</em>}' enum. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.ActivityParameterDirectionEnum
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityParameterDirectionEnum()
		 * @generated
		 */
		EEnum		ACTIVITY_PARAMETER_DIRECTION_ENUM				= MlsdmPackage.eINSTANCE.getActivityParameterDirectionEnum();

	}

} // MlsdmPackage
