/**
 */
package de.mdelab.mlsdm;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlexpressions.MLExpression;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Output Parameter Value</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> Specifies the return value of an ActivityParameter
 * using an expression. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.OutputParameterValue#getParameter <em>Parameter
 * </em>}</li>
 * <li>{@link de.mdelab.mlsdm.OutputParameterValue#getExpression <em>Expression
 * </em>}</li>
 * <li>{@link de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode <em>
 * Activity Final Node</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage#getOutputParameterValue()
 * @model
 * @generated
 */
public interface OutputParameterValue extends MLElementWithUUID, MLAnnotatedElement
{
	/**
	 * Returns the value of the '<em><b>Parameter</b></em>' reference. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameter</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Parameter</em>' reference.
	 * @see #setParameter(ActivityParameter)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getOutputParameterValue_Parameter()
	 * @model required="true"
	 * @generated
	 */
	ActivityParameter getParameter();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlsdm.OutputParameterValue#getParameter
	 * <em>Parameter</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Parameter</em>' reference.
	 * @see #getParameter()
	 * @generated
	 */
	void setParameter(ActivityParameter value);

	/**
	 * Returns the value of the '<em><b>Expression</b></em>' containment
	 * reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Expression</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Expression</em>' containment reference.
	 * @see #setExpression(MLExpression)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getOutputParameterValue_Expression()
	 * @model containment="true" required="true"
	 * @generated
	 */
	MLExpression getExpression();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlsdm.OutputParameterValue#getExpression
	 * <em>Expression</em>}' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Expression</em>' containment
	 *            reference.
	 * @see #getExpression()
	 * @generated
	 */
	void setExpression(MLExpression value);

	/**
	 * Returns the value of the '<em><b>Activity Final Node</b></em>' container
	 * reference. It is bidirectional and its opposite is '
	 * {@link de.mdelab.mlsdm.ActivityFinalNode#getOutputParameterValues
	 * <em>Output Parameter Values</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activity Final Node</em>' container reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Activity Final Node</em>' container
	 *         reference.
	 * @see #setActivityFinalNode(ActivityFinalNode)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getOutputParameterValue_ActivityFinalNode()
	 * @see de.mdelab.mlsdm.ActivityFinalNode#getOutputParameterValues
	 * @model opposite="outputParameterValues" resolveProxies="false"
	 *        required="true" transient="false"
	 * @generated
	 */
	ActivityFinalNode getActivityFinalNode();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode
	 * <em>Activity Final Node</em>}' container reference. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Activity Final Node</em>' container
	 *            reference.
	 * @see #getActivityFinalNode()
	 * @generated
	 */
	void setActivityFinalNode(ActivityFinalNode value);

} // OutputParameterValue
