/**
 */
package de.mdelab.mlsdm;

import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlstorypatterns.StoryPattern;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Story Node</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> A StoryNode contains a StoryPattern that is
 * executed. It can have SINGLE_MATCH or FOR_EACH semantics, i.e. only one or
 * all matches are sought. Depending on the semantics, the outgoing edges may
 * have different guards: SUCCESS and FAILURE for SINGLE_MATCH semantics,
 * FOR_EACH and END for FOR_EACH semantics. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.StoryNode#getStoryPattern <em>Story Pattern</em>}</li>
 * <li>{@link de.mdelab.mlsdm.StoryNode#getSemantics <em>Semantics</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage#getStoryNode()
 * @model
 * @generated
 */
public interface StoryNode extends ActivityNode, MLNamedElement
{
	/**
	 * Returns the value of the '<em><b>Story Pattern</b></em>' containment
	 * reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Story Pattern</em>' containment reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Story Pattern</em>' containment reference.
	 * @see #setStoryPattern(StoryPattern)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getStoryNode_StoryPattern()
	 * @model containment="true" required="true"
	 * @generated
	 */
	StoryPattern getStoryPattern();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.StoryNode#getStoryPattern
	 * <em>Story Pattern</em>}' containment reference. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Story Pattern</em>' containment
	 *            reference.
	 * @see #getStoryPattern()
	 * @generated
	 */
	void setStoryPattern(StoryPattern value);

	/**
	 * Returns the value of the '<em><b>Semantics</b></em>' attribute. The
	 * default value is <code>"SINGLE_MATCH"</code>. The literals are from the
	 * enumeration {@link de.mdelab.mlsdm.StoryNodeSemanticsEnum}. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Semantics</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Semantics</em>' attribute.
	 * @see de.mdelab.mlsdm.StoryNodeSemanticsEnum
	 * @see #setSemantics(StoryNodeSemanticsEnum)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getStoryNode_Semantics()
	 * @model default="SINGLE_MATCH" required="true"
	 * @generated
	 */
	StoryNodeSemanticsEnum getSemantics();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.StoryNode#getSemantics
	 * <em>Semantics</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Semantics</em>' attribute.
	 * @see de.mdelab.mlsdm.StoryNodeSemanticsEnum
	 * @see #getSemantics()
	 * @generated
	 */
	void setSemantics(StoryNodeSemanticsEnum value);

} // StoryNode
