/**
 */
package de.mdelab.mlsdm;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Synchronization Edge</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> Superclass for edges between Semaphores and
 * ActivityEdges. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.SynchronizationEdge#getActivityNodeContainer <em>
 * Activity Node Container</em>}</li>
 * <li>{@link de.mdelab.mlsdm.SynchronizationEdge#getWeight <em>Weight</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage#getSynchronizationEdge()
 * @model abstract="true"
 * @generated
 */
public interface SynchronizationEdge extends MLElementWithUUID, MLAnnotatedElement
{
	/**
	 * Returns the value of the '<em><b>Activity Node Container</b></em>'
	 * container reference. It is bidirectional and its opposite is '
	 * {@link de.mdelab.mlsdm.ActivityNodeContainer#getSynchronizationEdges
	 * <em>Synchronization Edges</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activity Node Container</em>' container
	 * reference isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Activity Node Container</em>' container
	 *         reference.
	 * @see #setActivityNodeContainer(ActivityNodeContainer)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getSynchronizationEdge_ActivityNodeContainer()
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getSynchronizationEdges
	 * @model opposite="synchronizationEdges" resolveProxies="false"
	 *        required="true" transient="false"
	 * @generated
	 */
	ActivityNodeContainer getActivityNodeContainer();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlsdm.SynchronizationEdge#getActivityNodeContainer
	 * <em>Activity Node Container</em>}' container reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Activity Node Container</em>'
	 *            container reference.
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	void setActivityNodeContainer(ActivityNodeContainer value);

	/**
	 * Returns the value of the '<em><b>Weight</b></em>' attribute. The default
	 * value is <code>"1"</code>. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * <!-- begin-model-doc --> The number of tokens acquired from/released to
	 * the token. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Weight</em>' attribute.
	 * @see #setWeight(int)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getSynchronizationEdge_Weight()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getWeight();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlsdm.SynchronizationEdge#getWeight <em>Weight</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Weight</em>' attribute.
	 * @see #getWeight()
	 * @generated
	 */
	void setWeight(int value);

} // SynchronizationEdge
