/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.ReleaseEdge;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Activity Edge</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getAnnotations <em>
 * Annotations</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getSource <em>Source</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getTarget <em>Target</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getActivityNodeContainer
 * <em>Activity Node Container</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getGuardType <em>Guard Type
 * </em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getGuardExpression <em>Guard
 * Expression</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getAcquireEdges <em>Acquire
 * Edges</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getReleaseEdges <em>Release
 * Edges</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getAssertionExpressions <em>
 * Assertion Expressions</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ActivityEdgeImpl extends MLElementWithUUIDImpl implements ActivityEdge
{
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation>					annotations;

	/**
	 * The cached value of the '{@link #getSource() <em>Source</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSource()
	 * @generated
	 * @ordered
	 */
	protected ActivityNode							source;

	/**
	 * The cached value of the '{@link #getTarget() <em>Target</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTarget()
	 * @generated
	 * @ordered
	 */
	protected ActivityNode							target;

	/**
	 * The default value of the '{@link #getGuardType() <em>Guard Type</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getGuardType()
	 * @generated
	 * @ordered
	 */
	protected static final ActivityEdgeGuardEnum	GUARD_TYPE_EDEFAULT	= ActivityEdgeGuardEnum.NONE;

	/**
	 * The cached value of the '{@link #getGuardType() <em>Guard Type</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getGuardType()
	 * @generated
	 * @ordered
	 */
	protected ActivityEdgeGuardEnum					guardType			= ActivityEdgeImpl.GUARD_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getGuardExpression()
	 * <em>Guard Expression</em>}' containment reference. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getGuardExpression()
	 * @generated
	 * @ordered
	 */
	protected MLExpression							guardExpression;

	/**
	 * The cached value of the '{@link #getAcquireEdges()
	 * <em>Acquire Edges</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getAcquireEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<AcquireEdge>					acquireEdges;

	/**
	 * The cached value of the '{@link #getReleaseEdges()
	 * <em>Release Edges</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getReleaseEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ReleaseEdge>					releaseEdges;

	/**
	 * The cached value of the '{@link #getAssertionExpressions()
	 * <em>Assertion Expressions</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAssertionExpressions()
	 * @generated
	 * @ordered
	 */
	protected EList<MLExpression>					assertionExpressions;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ActivityEdgeImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return MlsdmPackage.Literals.ACTIVITY_EDGE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations()
	{
		if (this.annotations == null)
		{
			this.annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(MLAnnotation.class, this,
					MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS, MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return this.annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityNode getSource()
	{
		return this.source;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetSource(final ActivityNode newSource, NotificationChain msgs)
	{
		final ActivityNode oldSource = this.source;
		this.source = newSource;
		if (this.eNotificationRequired())
		{
			final ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__SOURCE,
					oldSource, newSource);
			if (msgs == null)
			{
				msgs = notification;
			}
			else
			{
				msgs.add(notification);
			}
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setSource(final ActivityNode newSource)
	{
		if (newSource != this.source)
		{
			NotificationChain msgs = null;
			if (this.source != null)
			{
				msgs = ((InternalEObject) this.source).eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES, ActivityNode.class,
						msgs);
			}
			if (newSource != null)
			{
				msgs = ((InternalEObject) newSource)
						.eInverseAdd(this, MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES, ActivityNode.class, msgs);
			}
			msgs = this.basicSetSource(newSource, msgs);
			if (msgs != null)
			{
				msgs.dispatch();
			}
		}
		else if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__SOURCE, newSource, newSource));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityNode getTarget()
	{
		return this.target;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetTarget(final ActivityNode newTarget, NotificationChain msgs)
	{
		final ActivityNode oldTarget = this.target;
		this.target = newTarget;
		if (this.eNotificationRequired())
		{
			final ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__TARGET,
					oldTarget, newTarget);
			if (msgs == null)
			{
				msgs = notification;
			}
			else
			{
				msgs.add(notification);
			}
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setTarget(final ActivityNode newTarget)
	{
		if (newTarget != this.target)
		{
			NotificationChain msgs = null;
			if (this.target != null)
			{
				msgs = ((InternalEObject) this.target).eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES, ActivityNode.class,
						msgs);
			}
			if (newTarget != null)
			{
				msgs = ((InternalEObject) newTarget)
						.eInverseAdd(this, MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES, ActivityNode.class, msgs);
			}
			msgs = this.basicSetTarget(newTarget, msgs);
			if (msgs != null)
			{
				msgs.dispatch();
			}
		}
		else if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__TARGET, newTarget, newTarget));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityNodeContainer getActivityNodeContainer()
	{
		if (this.eContainerFeatureID() != MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER)
		{
			return null;
		}
		return (ActivityNodeContainer) this.eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetActivityNodeContainer(final ActivityNodeContainer newActivityNodeContainer, NotificationChain msgs)
	{
		msgs = this.eBasicSetContainer((InternalEObject) newActivityNodeContainer, MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setActivityNodeContainer(final ActivityNodeContainer newActivityNodeContainer)
	{
		if (newActivityNodeContainer != this.eInternalContainer()
				|| this.eContainerFeatureID() != MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER && newActivityNodeContainer != null)
		{
			if (EcoreUtil.isAncestor(this, newActivityNodeContainer))
			{
				throw new IllegalArgumentException("Recursive containment not allowed for " + this.toString());
			}
			NotificationChain msgs = null;
			if (this.eInternalContainer() != null)
			{
				msgs = this.eBasicRemoveFromContainer(msgs);
			}
			if (newActivityNodeContainer != null)
			{
				msgs = ((InternalEObject) newActivityNodeContainer).eInverseAdd(this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES,
						ActivityNodeContainer.class, msgs);
			}
			msgs = this.basicSetActivityNodeContainer(newActivityNodeContainer, msgs);
			if (msgs != null)
			{
				msgs.dispatch();
			}
		}
		else if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER,
					newActivityNodeContainer, newActivityNodeContainer));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityEdgeGuardEnum getGuardType()
	{
		return this.guardType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setGuardType(final ActivityEdgeGuardEnum newGuardType)
	{
		final ActivityEdgeGuardEnum oldGuardType = this.guardType;
		this.guardType = newGuardType == null ? ActivityEdgeImpl.GUARD_TYPE_EDEFAULT : newGuardType;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE, oldGuardType, this.guardType));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public MLExpression getGuardExpression()
	{
		return this.guardExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetGuardExpression(final MLExpression newGuardExpression, NotificationChain msgs)
	{
		final MLExpression oldGuardExpression = this.guardExpression;
		this.guardExpression = newGuardExpression;
		if (this.eNotificationRequired())
		{
			final ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION, oldGuardExpression, newGuardExpression);
			if (msgs == null)
			{
				msgs = notification;
			}
			else
			{
				msgs.add(notification);
			}
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setGuardExpression(final MLExpression newGuardExpression)
	{
		if (newGuardExpression != this.guardExpression)
		{
			NotificationChain msgs = null;
			if (this.guardExpression != null)
			{
				msgs = ((InternalEObject) this.guardExpression).eInverseRemove(this, InternalEObject.EOPPOSITE_FEATURE_BASE
						- MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION, null, msgs);
			}
			if (newGuardExpression != null)
			{
				msgs = ((InternalEObject) newGuardExpression).eInverseAdd(this, InternalEObject.EOPPOSITE_FEATURE_BASE
						- MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION, null, msgs);
			}
			msgs = this.basicSetGuardExpression(newGuardExpression, msgs);
			if (msgs != null)
			{
				msgs.dispatch();
			}
		}
		else if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION, newGuardExpression,
					newGuardExpression));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<AcquireEdge> getAcquireEdges()
	{
		if (this.acquireEdges == null)
		{
			this.acquireEdges = new EObjectWithInverseEList<AcquireEdge>(AcquireEdge.class, this,
					MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES, MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE);
		}
		return this.acquireEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ReleaseEdge> getReleaseEdges()
	{
		if (this.releaseEdges == null)
		{
			this.releaseEdges = new EObjectWithInverseEList<ReleaseEdge>(ReleaseEdge.class, this,
					MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES, MlsdmPackage.RELEASE_EDGE__ACTIVITY_EDGE);
		}
		return this.releaseEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<MLExpression> getAssertionExpressions()
	{
		if (this.assertionExpressions == null)
		{
			this.assertionExpressions = new EObjectContainmentEList<MLExpression>(MLExpression.class, this,
					MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS);
		}
		return this.assertionExpressions;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(final InternalEObject otherEnd, final int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getAnnotations()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
				if (this.source != null)
				{
					msgs = ((InternalEObject) this.source).eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES,
							ActivityNode.class, msgs);
				}
				return this.basicSetSource((ActivityNode) otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__TARGET:
				if (this.target != null)
				{
					msgs = ((InternalEObject) this.target).eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES,
							ActivityNode.class, msgs);
				}
				return this.basicSetTarget((ActivityNode) otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
				if (this.eInternalContainer() != null)
				{
					msgs = this.eBasicRemoveFromContainer(msgs);
				}
				return this.basicSetActivityNodeContainer((ActivityNodeContainer) otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getAcquireEdges()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getReleaseEdges()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
				return ((InternalEList<?>) this.getAnnotations()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
				return this.basicSetSource(null, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__TARGET:
				return this.basicSetTarget(null, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
				return this.basicSetActivityNodeContainer(null, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
				return this.basicSetGuardExpression(null, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
				return ((InternalEList<?>) this.getAcquireEdges()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
				return ((InternalEList<?>) this.getReleaseEdges()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
				return ((InternalEList<?>) this.getAssertionExpressions()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(final NotificationChain msgs)
	{
		switch (this.eContainerFeatureID())
		{
			case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
				return this.eInternalContainer().eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES,
						ActivityNodeContainer.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve, final boolean coreType)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
				return this.getAnnotations();
			case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
				return this.getSource();
			case MlsdmPackage.ACTIVITY_EDGE__TARGET:
				return this.getTarget();
			case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
				return this.getActivityNodeContainer();
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE:
				return this.getGuardType();
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
				return this.getGuardExpression();
			case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
				return this.getAcquireEdges();
			case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
				return this.getReleaseEdges();
			case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
				return this.getAssertionExpressions();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(final int featureID, final Object newValue)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
				this.getAnnotations().clear();
				this.getAnnotations().addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
				this.setSource((ActivityNode) newValue);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__TARGET:
				this.setTarget((ActivityNode) newValue);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
				this.setActivityNodeContainer((ActivityNodeContainer) newValue);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE:
				this.setGuardType((ActivityEdgeGuardEnum) newValue);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
				this.setGuardExpression((MLExpression) newValue);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
				this.getAcquireEdges().clear();
				this.getAcquireEdges().addAll((Collection<? extends AcquireEdge>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
				this.getReleaseEdges().clear();
				this.getReleaseEdges().addAll((Collection<? extends ReleaseEdge>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
				this.getAssertionExpressions().clear();
				this.getAssertionExpressions().addAll((Collection<? extends MLExpression>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
				this.getAnnotations().clear();
				return;
			case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
				this.setSource((ActivityNode) null);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__TARGET:
				this.setTarget((ActivityNode) null);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
				this.setActivityNodeContainer((ActivityNodeContainer) null);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE:
				this.setGuardType(ActivityEdgeImpl.GUARD_TYPE_EDEFAULT);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
				this.setGuardExpression((MLExpression) null);
				return;
			case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
				this.getAcquireEdges().clear();
				return;
			case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
				this.getReleaseEdges().clear();
				return;
			case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
				this.getAssertionExpressions().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
				return this.annotations != null && !this.annotations.isEmpty();
			case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
				return this.source != null;
			case MlsdmPackage.ACTIVITY_EDGE__TARGET:
				return this.target != null;
			case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
				return this.getActivityNodeContainer() != null;
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE:
				return this.guardType != ActivityEdgeImpl.GUARD_TYPE_EDEFAULT;
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
				return this.guardExpression != null;
			case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
				return this.acquireEdges != null && !this.acquireEdges.isEmpty();
			case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
				return this.releaseEdges != null && !this.releaseEdges.isEmpty();
			case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
				return this.assertionExpressions != null && !this.assertionExpressions.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(final int derivedFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(final int baseFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
					return MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString()
	{
		if (this.eIsProxy())
		{
			return super.toString();
		}

		final StringBuffer result = new StringBuffer(super.toString());
		result.append(" (guardType: ");
		result.append(this.guardType);
		result.append(')');
		return result.toString();
	}

} // ActivityEdgeImpl
