/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.SynchronizationEdge;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Activity</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getAnnotations <em>Annotations
 * </em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getName <em>Name</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getEdges <em>Edges</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getNodes <em>Nodes</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getSemaphores <em>Semaphores
 * </em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getSynchronizationEdges <em>
 * Synchronization Edges</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getParameters <em>Parameters
 * </em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ActivityImpl extends MLElementWithUUIDImpl implements Activity
{
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation>			annotations;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String			NAME_EDEFAULT	= null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String						name			= ActivityImpl.NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getEdges() <em>Edges</em>}' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge>			edges;

	/**
	 * The cached value of the '{@link #getNodes() <em>Nodes</em>}' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getNodes()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityNode>			nodes;

	/**
	 * The cached value of the '{@link #getSemaphores() <em>Semaphores</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSemaphores()
	 * @generated
	 * @ordered
	 */
	protected EList<Semaphore>				semaphores;

	/**
	 * The cached value of the '{@link #getSynchronizationEdges()
	 * <em>Synchronization Edges</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSynchronizationEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<SynchronizationEdge>	synchronizationEdges;

	/**
	 * The cached value of the '{@link #getParameters() <em>Parameters</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getParameters()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityParameter>		parameters;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ActivityImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return MlsdmPackage.Literals.ACTIVITY;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations()
	{
		if (this.annotations == null)
		{
			this.annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(MLAnnotation.class, this,
					MlsdmPackage.ACTIVITY__ANNOTATIONS, MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return this.annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getName()
	{
		return this.name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setName(final String newName)
	{
		final String oldName = this.name;
		this.name = newName;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY__NAME, oldName, this.name));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ActivityEdge> getEdges()
	{
		if (this.edges == null)
		{
			this.edges = new EObjectContainmentWithInverseEList<ActivityEdge>(ActivityEdge.class, this, MlsdmPackage.ACTIVITY__EDGES,
					MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER);
		}
		return this.edges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ActivityNode> getNodes()
	{
		if (this.nodes == null)
		{
			this.nodes = new EObjectContainmentWithInverseEList<ActivityNode>(ActivityNode.class, this, MlsdmPackage.ACTIVITY__NODES,
					MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER);
		}
		return this.nodes;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<Semaphore> getSemaphores()
	{
		if (this.semaphores == null)
		{
			this.semaphores = new EObjectContainmentWithInverseEList<Semaphore>(Semaphore.class, this, MlsdmPackage.ACTIVITY__SEMAPHORES,
					MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER);
		}
		return this.semaphores;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<SynchronizationEdge> getSynchronizationEdges()
	{
		if (this.synchronizationEdges == null)
		{
			this.synchronizationEdges = new EObjectContainmentWithInverseEList<SynchronizationEdge>(SynchronizationEdge.class, this,
					MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES, MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER);
		}
		return this.synchronizationEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ActivityParameter> getParameters()
	{
		if (this.parameters == null)
		{
			this.parameters = new EObjectContainmentWithInverseEList<ActivityParameter>(ActivityParameter.class, this,
					MlsdmPackage.ACTIVITY__PARAMETERS, MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY);
		}
		return this.parameters;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY__ANNOTATIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getAnnotations()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getEdges()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__NODES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getNodes()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__SEMAPHORES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getSemaphores()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getSynchronizationEdges()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__PARAMETERS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getParameters()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY__ANNOTATIONS:
				return ((InternalEList<?>) this.getAnnotations()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__EDGES:
				return ((InternalEList<?>) this.getEdges()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__NODES:
				return ((InternalEList<?>) this.getNodes()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__SEMAPHORES:
				return ((InternalEList<?>) this.getSemaphores()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
				return ((InternalEList<?>) this.getSynchronizationEdges()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY__PARAMETERS:
				return ((InternalEList<?>) this.getParameters()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve, final boolean coreType)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY__ANNOTATIONS:
				return this.getAnnotations();
			case MlsdmPackage.ACTIVITY__NAME:
				return this.getName();
			case MlsdmPackage.ACTIVITY__EDGES:
				return this.getEdges();
			case MlsdmPackage.ACTIVITY__NODES:
				return this.getNodes();
			case MlsdmPackage.ACTIVITY__SEMAPHORES:
				return this.getSemaphores();
			case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
				return this.getSynchronizationEdges();
			case MlsdmPackage.ACTIVITY__PARAMETERS:
				return this.getParameters();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(final int featureID, final Object newValue)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY__ANNOTATIONS:
				this.getAnnotations().clear();
				this.getAnnotations().addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlsdmPackage.ACTIVITY__NAME:
				this.setName((String) newValue);
				return;
			case MlsdmPackage.ACTIVITY__EDGES:
				this.getEdges().clear();
				this.getEdges().addAll((Collection<? extends ActivityEdge>) newValue);
				return;
			case MlsdmPackage.ACTIVITY__NODES:
				this.getNodes().clear();
				this.getNodes().addAll((Collection<? extends ActivityNode>) newValue);
				return;
			case MlsdmPackage.ACTIVITY__SEMAPHORES:
				this.getSemaphores().clear();
				this.getSemaphores().addAll((Collection<? extends Semaphore>) newValue);
				return;
			case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
				this.getSynchronizationEdges().clear();
				this.getSynchronizationEdges().addAll((Collection<? extends SynchronizationEdge>) newValue);
				return;
			case MlsdmPackage.ACTIVITY__PARAMETERS:
				this.getParameters().clear();
				this.getParameters().addAll((Collection<? extends ActivityParameter>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY__ANNOTATIONS:
				this.getAnnotations().clear();
				return;
			case MlsdmPackage.ACTIVITY__NAME:
				this.setName(ActivityImpl.NAME_EDEFAULT);
				return;
			case MlsdmPackage.ACTIVITY__EDGES:
				this.getEdges().clear();
				return;
			case MlsdmPackage.ACTIVITY__NODES:
				this.getNodes().clear();
				return;
			case MlsdmPackage.ACTIVITY__SEMAPHORES:
				this.getSemaphores().clear();
				return;
			case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
				this.getSynchronizationEdges().clear();
				return;
			case MlsdmPackage.ACTIVITY__PARAMETERS:
				this.getParameters().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY__ANNOTATIONS:
				return this.annotations != null && !this.annotations.isEmpty();
			case MlsdmPackage.ACTIVITY__NAME:
				return ActivityImpl.NAME_EDEFAULT == null ? this.name != null : !ActivityImpl.NAME_EDEFAULT.equals(this.name);
			case MlsdmPackage.ACTIVITY__EDGES:
				return this.edges != null && !this.edges.isEmpty();
			case MlsdmPackage.ACTIVITY__NODES:
				return this.nodes != null && !this.nodes.isEmpty();
			case MlsdmPackage.ACTIVITY__SEMAPHORES:
				return this.semaphores != null && !this.semaphores.isEmpty();
			case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
				return this.synchronizationEdges != null && !this.synchronizationEdges.isEmpty();
			case MlsdmPackage.ACTIVITY__PARAMETERS:
				return this.parameters != null && !this.parameters.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(final int derivedFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.ACTIVITY__ANNOTATIONS:
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default:
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.ACTIVITY__NAME:
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default:
					return -1;
			}
		}
		if (baseClass == ActivityNodeContainer.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.ACTIVITY__EDGES:
					return MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES;
				case MlsdmPackage.ACTIVITY__NODES:
					return MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES;
				case MlsdmPackage.ACTIVITY__SEMAPHORES:
					return MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES;
				case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
					return MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(final int baseFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
					return MlsdmPackage.ACTIVITY__ANNOTATIONS;
				default:
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_NAMED_ELEMENT__NAME:
					return MlsdmPackage.ACTIVITY__NAME;
				default:
					return -1;
			}
		}
		if (baseClass == ActivityNodeContainer.class)
		{
			switch (baseFeatureID)
			{
				case MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES:
					return MlsdmPackage.ACTIVITY__EDGES;
				case MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES:
					return MlsdmPackage.ACTIVITY__NODES;
				case MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES:
					return MlsdmPackage.ACTIVITY__SEMAPHORES;
				case MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES:
					return MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString()
	{
		if (this.eIsProxy())
		{
			return super.toString();
		}

		final StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(this.name);
		result.append(')');
		return result.toString();
	}

} // ActivityImpl
