/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.MlsdmPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Activity Node</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityNodeImpl#getAnnotations <em>
 * Annotations</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityNodeImpl#getOutgoingEdges <em>
 * Outgoing Edges</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityNodeImpl#getIncomingEdges <em>
 * Incoming Edges</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityNodeImpl#getActivityNodeContainer
 * <em>Activity Node Container</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class ActivityNodeImpl extends MLElementWithUUIDImpl implements ActivityNode
{
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation>	annotations;

	/**
	 * The cached value of the '{@link #getOutgoingEdges()
	 * <em>Outgoing Edges</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getOutgoingEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge>	outgoingEdges;

	/**
	 * The cached value of the '{@link #getIncomingEdges()
	 * <em>Incoming Edges</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getIncomingEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge>	incomingEdges;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ActivityNodeImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return MlsdmPackage.Literals.ACTIVITY_NODE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations()
	{
		if (this.annotations == null)
		{
			this.annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(MLAnnotation.class, this,
					MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS, MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return this.annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ActivityEdge> getOutgoingEdges()
	{
		if (this.outgoingEdges == null)
		{
			this.outgoingEdges = new EObjectWithInverseEList<ActivityEdge>(ActivityEdge.class, this,
					MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES, MlsdmPackage.ACTIVITY_EDGE__SOURCE);
		}
		return this.outgoingEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ActivityEdge> getIncomingEdges()
	{
		if (this.incomingEdges == null)
		{
			this.incomingEdges = new EObjectWithInverseEList<ActivityEdge>(ActivityEdge.class, this,
					MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES, MlsdmPackage.ACTIVITY_EDGE__TARGET);
		}
		return this.incomingEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityNodeContainer getActivityNodeContainer()
	{
		if (this.eContainerFeatureID() != MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER)
		{
			return null;
		}
		return (ActivityNodeContainer) this.eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetActivityNodeContainer(final ActivityNodeContainer newActivityNodeContainer, NotificationChain msgs)
	{
		msgs = this.eBasicSetContainer((InternalEObject) newActivityNodeContainer, MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setActivityNodeContainer(final ActivityNodeContainer newActivityNodeContainer)
	{
		if (newActivityNodeContainer != this.eInternalContainer()
				|| this.eContainerFeatureID() != MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER && newActivityNodeContainer != null)
		{
			if (EcoreUtil.isAncestor(this, newActivityNodeContainer))
			{
				throw new IllegalArgumentException("Recursive containment not allowed for " + this.toString());
			}
			NotificationChain msgs = null;
			if (this.eInternalContainer() != null)
			{
				msgs = this.eBasicRemoveFromContainer(msgs);
			}
			if (newActivityNodeContainer != null)
			{
				msgs = ((InternalEObject) newActivityNodeContainer).eInverseAdd(this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES,
						ActivityNodeContainer.class, msgs);
			}
			msgs = this.basicSetActivityNodeContainer(newActivityNodeContainer, msgs);
			if (msgs != null)
			{
				msgs.dispatch();
			}
		}
		else if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER,
					newActivityNodeContainer, newActivityNodeContainer));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(final InternalEObject otherEnd, final int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getAnnotations()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getOutgoingEdges()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getIncomingEdges()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER:
				if (this.eInternalContainer() != null)
				{
					msgs = this.eBasicRemoveFromContainer(msgs);
				}
				return this.basicSetActivityNodeContainer((ActivityNodeContainer) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS:
				return ((InternalEList<?>) this.getAnnotations()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES:
				return ((InternalEList<?>) this.getOutgoingEdges()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES:
				return ((InternalEList<?>) this.getIncomingEdges()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER:
				return this.basicSetActivityNodeContainer(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(final NotificationChain msgs)
	{
		switch (this.eContainerFeatureID())
		{
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER:
				return this.eInternalContainer().eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES,
						ActivityNodeContainer.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve, final boolean coreType)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS:
				return this.getAnnotations();
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES:
				return this.getOutgoingEdges();
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES:
				return this.getIncomingEdges();
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER:
				return this.getActivityNodeContainer();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(final int featureID, final Object newValue)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS:
				this.getAnnotations().clear();
				this.getAnnotations().addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES:
				this.getOutgoingEdges().clear();
				this.getOutgoingEdges().addAll((Collection<? extends ActivityEdge>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES:
				this.getIncomingEdges().clear();
				this.getIncomingEdges().addAll((Collection<? extends ActivityEdge>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER:
				this.setActivityNodeContainer((ActivityNodeContainer) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS:
				this.getAnnotations().clear();
				return;
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES:
				this.getOutgoingEdges().clear();
				return;
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES:
				this.getIncomingEdges().clear();
				return;
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER:
				this.setActivityNodeContainer((ActivityNodeContainer) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS:
				return this.annotations != null && !this.annotations.isEmpty();
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES:
				return this.outgoingEdges != null && !this.outgoingEdges.isEmpty();
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES:
				return this.incomingEdges != null && !this.incomingEdges.isEmpty();
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER:
				return this.getActivityNodeContainer() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(final int derivedFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS:
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(final int baseFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
					return MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} // ActivityNodeImpl
