/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;
import de.mdelab.mlsdm.MlsdmPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Activity Parameter</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getAnnotations <em>
 * Annotations</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getName <em>Name</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getType <em>Type</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getDirection <em>
 * Direction</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getActivity <em>
 * Activity</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ActivityParameterImpl extends MLElementWithUUIDImpl implements ActivityParameter
{
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation>							annotations;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String							NAME_EDEFAULT		= null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String										name				= ActivityParameterImpl.NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected EClassifier									type;

	/**
	 * The default value of the '{@link #getDirection() <em>Direction</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDirection()
	 * @generated
	 * @ordered
	 */
	protected static final ActivityParameterDirectionEnum	DIRECTION_EDEFAULT	= ActivityParameterDirectionEnum.IN;

	/**
	 * The cached value of the '{@link #getDirection() <em>Direction</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDirection()
	 * @generated
	 * @ordered
	 */
	protected ActivityParameterDirectionEnum				direction			= ActivityParameterImpl.DIRECTION_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ActivityParameterImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return MlsdmPackage.Literals.ACTIVITY_PARAMETER;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations()
	{
		if (this.annotations == null)
		{
			this.annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(MLAnnotation.class, this,
					MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS, MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return this.annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getName()
	{
		return this.name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setName(final String newName)
	{
		final String oldName = this.name;
		this.name = newName;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_PARAMETER__NAME, oldName, this.name));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EClassifier getType()
	{
		if (this.type != null && this.type.eIsProxy())
		{
			final InternalEObject oldType = (InternalEObject) this.type;
			this.type = (EClassifier) this.eResolveProxy(oldType);
			if (this.type != oldType)
			{
				if (this.eNotificationRequired())
				{
					this.eNotify(new ENotificationImpl(this, Notification.RESOLVE, MlsdmPackage.ACTIVITY_PARAMETER__TYPE, oldType,
							this.type));
				}
			}
		}
		return this.type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClassifier basicGetType()
	{
		return this.type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setType(final EClassifier newType)
	{
		final EClassifier oldType = this.type;
		this.type = newType;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_PARAMETER__TYPE, oldType, this.type));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityParameterDirectionEnum getDirection()
	{
		return this.direction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setDirection(final ActivityParameterDirectionEnum newDirection)
	{
		final ActivityParameterDirectionEnum oldDirection = this.direction;
		this.direction = newDirection == null ? ActivityParameterImpl.DIRECTION_EDEFAULT : newDirection;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION, oldDirection,
					this.direction));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Activity getActivity()
	{
		if (this.eContainerFeatureID() != MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY)
		{
			return null;
		}
		return (Activity) this.eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetActivity(final Activity newActivity, NotificationChain msgs)
	{
		msgs = this.eBasicSetContainer((InternalEObject) newActivity, MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setActivity(final Activity newActivity)
	{
		if (newActivity != this.eInternalContainer() || this.eContainerFeatureID() != MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY
				&& newActivity != null)
		{
			if (EcoreUtil.isAncestor(this, newActivity))
			{
				throw new IllegalArgumentException("Recursive containment not allowed for " + this.toString());
			}
			NotificationChain msgs = null;
			if (this.eInternalContainer() != null)
			{
				msgs = this.eBasicRemoveFromContainer(msgs);
			}
			if (newActivity != null)
			{
				msgs = ((InternalEObject) newActivity).eInverseAdd(this, MlsdmPackage.ACTIVITY__PARAMETERS, Activity.class, msgs);
			}
			msgs = this.basicSetActivity(newActivity, msgs);
			if (msgs != null)
			{
				msgs.dispatch();
			}
		}
		else if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY, newActivity, newActivity));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(final InternalEObject otherEnd, final int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getAnnotations()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY:
				if (this.eInternalContainer() != null)
				{
					msgs = this.eBasicRemoveFromContainer(msgs);
				}
				return this.basicSetActivity((Activity) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS:
				return ((InternalEList<?>) this.getAnnotations()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY:
				return this.basicSetActivity(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(final NotificationChain msgs)
	{
		switch (this.eContainerFeatureID())
		{
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY:
				return this.eInternalContainer().eInverseRemove(this, MlsdmPackage.ACTIVITY__PARAMETERS, Activity.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve, final boolean coreType)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS:
				return this.getAnnotations();
			case MlsdmPackage.ACTIVITY_PARAMETER__NAME:
				return this.getName();
			case MlsdmPackage.ACTIVITY_PARAMETER__TYPE:
				if (resolve)
				{
					return this.getType();
				}
				return this.basicGetType();
			case MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION:
				return this.getDirection();
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY:
				return this.getActivity();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(final int featureID, final Object newValue)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS:
				this.getAnnotations().clear();
				this.getAnnotations().addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__NAME:
				this.setName((String) newValue);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__TYPE:
				this.setType((EClassifier) newValue);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION:
				this.setDirection((ActivityParameterDirectionEnum) newValue);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY:
				this.setActivity((Activity) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS:
				this.getAnnotations().clear();
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__NAME:
				this.setName(ActivityParameterImpl.NAME_EDEFAULT);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__TYPE:
				this.setType((EClassifier) null);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION:
				this.setDirection(ActivityParameterImpl.DIRECTION_EDEFAULT);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY:
				this.setActivity((Activity) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS:
				return this.annotations != null && !this.annotations.isEmpty();
			case MlsdmPackage.ACTIVITY_PARAMETER__NAME:
				return ActivityParameterImpl.NAME_EDEFAULT == null ? this.name != null : !ActivityParameterImpl.NAME_EDEFAULT
						.equals(this.name);
			case MlsdmPackage.ACTIVITY_PARAMETER__TYPE:
				return this.type != null;
			case MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION:
				return this.direction != ActivityParameterImpl.DIRECTION_EDEFAULT;
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY:
				return this.getActivity() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(final int derivedFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS:
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default:
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.ACTIVITY_PARAMETER__NAME:
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default:
					return -1;
			}
		}
		if (baseClass == MLTypedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.ACTIVITY_PARAMETER__TYPE:
					return MlcorePackage.ML_TYPED_ELEMENT__TYPE;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(final int baseFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
					return MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS;
				default:
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_NAMED_ELEMENT__NAME:
					return MlsdmPackage.ACTIVITY_PARAMETER__NAME;
				default:
					return -1;
			}
		}
		if (baseClass == MLTypedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_TYPED_ELEMENT__TYPE:
					return MlsdmPackage.ACTIVITY_PARAMETER__TYPE;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString()
	{
		if (this.eIsProxy())
		{
			return super.toString();
		}

		final StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(this.name);
		result.append(", direction: ");
		result.append(this.direction);
		result.append(')');
		return result.toString();
	}

} // ActivityParameterImpl
