/**
 */
package de.mdelab.mlsdm.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.mlsdm.FlowFinalNode;
import de.mdelab.mlsdm.ForkJoinNode;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.MlsdmFactory;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.OutputParameterValue;
import de.mdelab.mlsdm.ReleaseEdge;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StoryNodeSemanticsEnum;
import de.mdelab.mlsdm.StructuredNode;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class MlsdmFactoryImpl extends EFactoryImpl implements MlsdmFactory
{
	/**
	 * Creates the default factory implementation. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static MlsdmFactory init()
	{
		try
		{
			final MlsdmFactory theMlsdmFactory = (MlsdmFactory) EPackage.Registry.INSTANCE.getEFactory("http://www.mdelab.de/mlsdm/1.0");
			if (theMlsdmFactory != null)
			{
				return theMlsdmFactory;
			}
		}
		catch (final Exception exception)
		{
			EcorePlugin.INSTANCE.log(exception);
		}
		return new MlsdmFactoryImpl();
	}

	/**
	 * Creates an instance of the factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public MlsdmFactoryImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EObject create(final EClass eClass)
	{
		switch (eClass.getClassifierID())
		{
			case MlsdmPackage.ACTIVITY:
				return this.createActivity();
			case MlsdmPackage.ACTIVITY_EDGE:
				return this.createActivityEdge();
			case MlsdmPackage.INITIAL_NODE:
				return this.createInitialNode();
			case MlsdmPackage.FLOW_FINAL_NODE:
				return this.createFlowFinalNode();
			case MlsdmPackage.ACTIVITY_FINAL_NODE:
				return this.createActivityFinalNode();
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE:
				return this.createExpressionActivityNode();
			case MlsdmPackage.DECISION_MERGE_NODE:
				return this.createDecisionMergeNode();
			case MlsdmPackage.FORK_JOIN_NODE:
				return this.createForkJoinNode();
			case MlsdmPackage.STORY_NODE:
				return this.createStoryNode();
			case MlsdmPackage.STRUCTURED_NODE:
				return this.createStructuredNode();
			case MlsdmPackage.SEMAPHORE:
				return this.createSemaphore();
			case MlsdmPackage.ACQUIRE_EDGE:
				return this.createAcquireEdge();
			case MlsdmPackage.RELEASE_EDGE:
				return this.createReleaseEdge();
			case MlsdmPackage.ACTIVITY_PARAMETER:
				return this.createActivityParameter();
			case MlsdmPackage.OUTPUT_PARAMETER_VALUE:
				return this.createOutputParameterValue();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object createFromString(final EDataType eDataType, final String initialValue)
	{
		switch (eDataType.getClassifierID())
		{
			case MlsdmPackage.ACTIVITY_EDGE_GUARD_ENUM:
				return this.createActivityEdgeGuardEnumFromString(eDataType, initialValue);
			case MlsdmPackage.STORY_NODE_SEMANTICS_ENUM:
				return this.createStoryNodeSemanticsEnumFromString(eDataType, initialValue);
			case MlsdmPackage.ACTIVITY_PARAMETER_DIRECTION_ENUM:
				return this.createActivityParameterDirectionEnumFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String convertToString(final EDataType eDataType, final Object instanceValue)
	{
		switch (eDataType.getClassifierID())
		{
			case MlsdmPackage.ACTIVITY_EDGE_GUARD_ENUM:
				return this.convertActivityEdgeGuardEnumToString(eDataType, instanceValue);
			case MlsdmPackage.STORY_NODE_SEMANTICS_ENUM:
				return this.convertStoryNodeSemanticsEnumToString(eDataType, instanceValue);
			case MlsdmPackage.ACTIVITY_PARAMETER_DIRECTION_ENUM:
				return this.convertActivityParameterDirectionEnumToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Activity createActivity()
	{
		final ActivityImpl activity = new ActivityImpl();
		return activity;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityEdge createActivityEdge()
	{
		final ActivityEdgeImpl activityEdge = new ActivityEdgeImpl();
		return activityEdge;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public InitialNode createInitialNode()
	{
		final InitialNodeImpl initialNode = new InitialNodeImpl();
		return initialNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public FlowFinalNode createFlowFinalNode()
	{
		final FlowFinalNodeImpl flowFinalNode = new FlowFinalNodeImpl();
		return flowFinalNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityFinalNode createActivityFinalNode()
	{
		final ActivityFinalNodeImpl activityFinalNode = new ActivityFinalNodeImpl();
		return activityFinalNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ExpressionActivityNode createExpressionActivityNode()
	{
		final ExpressionActivityNodeImpl expressionActivityNode = new ExpressionActivityNodeImpl();
		return expressionActivityNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public DecisionMergeNode createDecisionMergeNode()
	{
		final DecisionMergeNodeImpl decisionMergeNode = new DecisionMergeNodeImpl();
		return decisionMergeNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ForkJoinNode createForkJoinNode()
	{
		final ForkJoinNodeImpl forkJoinNode = new ForkJoinNodeImpl();
		return forkJoinNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public StoryNode createStoryNode()
	{
		final StoryNodeImpl storyNode = new StoryNodeImpl();
		return storyNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public StructuredNode createStructuredNode()
	{
		final StructuredNodeImpl structuredNode = new StructuredNodeImpl();
		return structuredNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Semaphore createSemaphore()
	{
		final SemaphoreImpl semaphore = new SemaphoreImpl();
		return semaphore;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public AcquireEdge createAcquireEdge()
	{
		final AcquireEdgeImpl acquireEdge = new AcquireEdgeImpl();
		return acquireEdge;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ReleaseEdge createReleaseEdge()
	{
		final ReleaseEdgeImpl releaseEdge = new ReleaseEdgeImpl();
		return releaseEdge;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityParameter createActivityParameter()
	{
		final ActivityParameterImpl activityParameter = new ActivityParameterImpl();
		return activityParameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public OutputParameterValue createOutputParameterValue()
	{
		final OutputParameterValueImpl outputParameterValue = new OutputParameterValueImpl();
		return outputParameterValue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ActivityEdgeGuardEnum createActivityEdgeGuardEnumFromString(final EDataType eDataType, final String initialValue)
	{
		final ActivityEdgeGuardEnum result = ActivityEdgeGuardEnum.get(initialValue);
		if (result == null)
		{
			throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		}
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertActivityEdgeGuardEnumToString(final EDataType eDataType, final Object instanceValue)
	{
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StoryNodeSemanticsEnum createStoryNodeSemanticsEnumFromString(final EDataType eDataType, final String initialValue)
	{
		final StoryNodeSemanticsEnum result = StoryNodeSemanticsEnum.get(initialValue);
		if (result == null)
		{
			throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		}
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertStoryNodeSemanticsEnumToString(final EDataType eDataType, final Object instanceValue)
	{
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ActivityParameterDirectionEnum createActivityParameterDirectionEnumFromString(final EDataType eDataType,
			final String initialValue)
	{
		final ActivityParameterDirectionEnum result = ActivityParameterDirectionEnum.get(initialValue);
		if (result == null)
		{
			throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		}
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertActivityParameterDirectionEnumToString(final EDataType eDataType, final Object instanceValue)
	{
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public MlsdmPackage getMlsdmPackage()
	{
		return (MlsdmPackage) this.getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static MlsdmPackage getPackage()
	{
		return MlsdmPackage.eINSTANCE;
	}

} // MlsdmFactoryImpl
