/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.ReleaseEdge;
import de.mdelab.mlsdm.Semaphore;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Semaphore</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getAnnotations <em>Annotations
 * </em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getName <em>Name</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getActivityNodeContainer <em>
 * Activity Node Container</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getTokenCount <em>Token Count
 * </em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getAcquireEdges <em>Acquire
 * Edges</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getReleaseEdges <em>Release
 * Edges</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class SemaphoreImpl extends MLElementWithUUIDImpl implements Semaphore
{
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation>	annotations;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String	NAME_EDEFAULT			= null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String				name					= SemaphoreImpl.NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getTokenCount() <em>Token Count</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTokenCount()
	 * @generated
	 * @ordered
	 */
	protected static final int		TOKEN_COUNT_EDEFAULT	= 1;

	/**
	 * The cached value of the '{@link #getTokenCount() <em>Token Count</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTokenCount()
	 * @generated
	 * @ordered
	 */
	protected int					tokenCount				= SemaphoreImpl.TOKEN_COUNT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAcquireEdges()
	 * <em>Acquire Edges</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getAcquireEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<AcquireEdge>	acquireEdges;

	/**
	 * The cached value of the '{@link #getReleaseEdges()
	 * <em>Release Edges</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getReleaseEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ReleaseEdge>	releaseEdges;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SemaphoreImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return MlsdmPackage.Literals.SEMAPHORE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations()
	{
		if (this.annotations == null)
		{
			this.annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(MLAnnotation.class, this,
					MlsdmPackage.SEMAPHORE__ANNOTATIONS, MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return this.annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getName()
	{
		return this.name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setName(final String newName)
	{
		final String oldName = this.name;
		this.name = newName;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.SEMAPHORE__NAME, oldName, this.name));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityNodeContainer getActivityNodeContainer()
	{
		if (this.eContainerFeatureID() != MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER)
		{
			return null;
		}
		return (ActivityNodeContainer) this.eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetActivityNodeContainer(final ActivityNodeContainer newActivityNodeContainer, NotificationChain msgs)
	{
		msgs = this.eBasicSetContainer((InternalEObject) newActivityNodeContainer, MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setActivityNodeContainer(final ActivityNodeContainer newActivityNodeContainer)
	{
		if (newActivityNodeContainer != this.eInternalContainer()
				|| this.eContainerFeatureID() != MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER && newActivityNodeContainer != null)
		{
			if (EcoreUtil.isAncestor(this, newActivityNodeContainer))
			{
				throw new IllegalArgumentException("Recursive containment not allowed for " + this.toString());
			}
			NotificationChain msgs = null;
			if (this.eInternalContainer() != null)
			{
				msgs = this.eBasicRemoveFromContainer(msgs);
			}
			if (newActivityNodeContainer != null)
			{
				msgs = ((InternalEObject) newActivityNodeContainer).eInverseAdd(this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES,
						ActivityNodeContainer.class, msgs);
			}
			msgs = this.basicSetActivityNodeContainer(newActivityNodeContainer, msgs);
			if (msgs != null)
			{
				msgs.dispatch();
			}
		}
		else if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER,
					newActivityNodeContainer, newActivityNodeContainer));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int getTokenCount()
	{
		return this.tokenCount;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setTokenCount(final int newTokenCount)
	{
		final int oldTokenCount = this.tokenCount;
		this.tokenCount = newTokenCount;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.SEMAPHORE__TOKEN_COUNT, oldTokenCount, this.tokenCount));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<AcquireEdge> getAcquireEdges()
	{
		if (this.acquireEdges == null)
		{
			this.acquireEdges = new EObjectWithInverseEList<AcquireEdge>(AcquireEdge.class, this, MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES,
					MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE);
		}
		return this.acquireEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ReleaseEdge> getReleaseEdges()
	{
		if (this.releaseEdges == null)
		{
			this.releaseEdges = new EObjectWithInverseEList<ReleaseEdge>(ReleaseEdge.class, this, MlsdmPackage.SEMAPHORE__RELEASE_EDGES,
					MlsdmPackage.RELEASE_EDGE__SEMAPHORE);
		}
		return this.releaseEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(final InternalEObject otherEnd, final int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getAnnotations()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER:
				if (this.eInternalContainer() != null)
				{
					msgs = this.eBasicRemoveFromContainer(msgs);
				}
				return this.basicSetActivityNodeContainer((ActivityNodeContainer) otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getAcquireEdges()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getReleaseEdges()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS:
				return ((InternalEList<?>) this.getAnnotations()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER:
				return this.basicSetActivityNodeContainer(null, msgs);
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES:
				return ((InternalEList<?>) this.getAcquireEdges()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES:
				return ((InternalEList<?>) this.getReleaseEdges()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(final NotificationChain msgs)
	{
		switch (this.eContainerFeatureID())
		{
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER:
				return this.eInternalContainer().eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES,
						ActivityNodeContainer.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve, final boolean coreType)
	{
		switch (featureID)
		{
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS:
				return this.getAnnotations();
			case MlsdmPackage.SEMAPHORE__NAME:
				return this.getName();
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER:
				return this.getActivityNodeContainer();
			case MlsdmPackage.SEMAPHORE__TOKEN_COUNT:
				return this.getTokenCount();
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES:
				return this.getAcquireEdges();
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES:
				return this.getReleaseEdges();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(final int featureID, final Object newValue)
	{
		switch (featureID)
		{
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS:
				this.getAnnotations().clear();
				this.getAnnotations().addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__NAME:
				this.setName((String) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER:
				this.setActivityNodeContainer((ActivityNodeContainer) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__TOKEN_COUNT:
				this.setTokenCount((Integer) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES:
				this.getAcquireEdges().clear();
				this.getAcquireEdges().addAll((Collection<? extends AcquireEdge>) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES:
				this.getReleaseEdges().clear();
				this.getReleaseEdges().addAll((Collection<? extends ReleaseEdge>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS:
				this.getAnnotations().clear();
				return;
			case MlsdmPackage.SEMAPHORE__NAME:
				this.setName(SemaphoreImpl.NAME_EDEFAULT);
				return;
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER:
				this.setActivityNodeContainer((ActivityNodeContainer) null);
				return;
			case MlsdmPackage.SEMAPHORE__TOKEN_COUNT:
				this.setTokenCount(SemaphoreImpl.TOKEN_COUNT_EDEFAULT);
				return;
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES:
				this.getAcquireEdges().clear();
				return;
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES:
				this.getReleaseEdges().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS:
				return this.annotations != null && !this.annotations.isEmpty();
			case MlsdmPackage.SEMAPHORE__NAME:
				return SemaphoreImpl.NAME_EDEFAULT == null ? this.name != null : !SemaphoreImpl.NAME_EDEFAULT.equals(this.name);
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER:
				return this.getActivityNodeContainer() != null;
			case MlsdmPackage.SEMAPHORE__TOKEN_COUNT:
				return this.tokenCount != SemaphoreImpl.TOKEN_COUNT_EDEFAULT;
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES:
				return this.acquireEdges != null && !this.acquireEdges.isEmpty();
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES:
				return this.releaseEdges != null && !this.releaseEdges.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(final int derivedFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.SEMAPHORE__ANNOTATIONS:
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default:
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.SEMAPHORE__NAME:
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(final int baseFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
					return MlsdmPackage.SEMAPHORE__ANNOTATIONS;
				default:
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_NAMED_ELEMENT__NAME:
					return MlsdmPackage.SEMAPHORE__NAME;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString()
	{
		if (this.eIsProxy())
		{
			return super.toString();
		}

		final StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(this.name);
		result.append(", tokenCount: ");
		result.append(this.tokenCount);
		result.append(')');
		return result.toString();
	}

} // SemaphoreImpl
