/**
 */
package de.mdelab.mlsdm.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StoryNodeSemanticsEnum;
import de.mdelab.mlstorypatterns.StoryPattern;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Node</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.impl.StoryNodeImpl#getName <em>Name</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.StoryNodeImpl#getStoryPattern <em>Story
 * Pattern</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.StoryNodeImpl#getSemantics <em>Semantics
 * </em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class StoryNodeImpl extends ActivityNodeImpl implements StoryNode
{
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String					NAME_EDEFAULT		= null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String								name				= StoryNodeImpl.NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStoryPattern()
	 * <em>Story Pattern</em>}' containment reference. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getStoryPattern()
	 * @generated
	 * @ordered
	 */
	protected StoryPattern							storyPattern;

	/**
	 * The default value of the '{@link #getSemantics() <em>Semantics</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSemantics()
	 * @generated
	 * @ordered
	 */
	protected static final StoryNodeSemanticsEnum	SEMANTICS_EDEFAULT	= StoryNodeSemanticsEnum.SINGLE_MATCH;

	/**
	 * The cached value of the '{@link #getSemantics() <em>Semantics</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSemantics()
	 * @generated
	 * @ordered
	 */
	protected StoryNodeSemanticsEnum				semantics			= StoryNodeImpl.SEMANTICS_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected StoryNodeImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return MlsdmPackage.Literals.STORY_NODE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getName()
	{
		return this.name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setName(final String newName)
	{
		final String oldName = this.name;
		this.name = newName;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.STORY_NODE__NAME, oldName, this.name));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public StoryPattern getStoryPattern()
	{
		return this.storyPattern;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetStoryPattern(final StoryPattern newStoryPattern, NotificationChain msgs)
	{
		final StoryPattern oldStoryPattern = this.storyPattern;
		this.storyPattern = newStoryPattern;
		if (this.eNotificationRequired())
		{
			final ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MlsdmPackage.STORY_NODE__STORY_PATTERN,
					oldStoryPattern, newStoryPattern);
			if (msgs == null)
			{
				msgs = notification;
			}
			else
			{
				msgs.add(notification);
			}
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setStoryPattern(final StoryPattern newStoryPattern)
	{
		if (newStoryPattern != this.storyPattern)
		{
			NotificationChain msgs = null;
			if (this.storyPattern != null)
			{
				msgs = ((InternalEObject) this.storyPattern).eInverseRemove(this, InternalEObject.EOPPOSITE_FEATURE_BASE
						- MlsdmPackage.STORY_NODE__STORY_PATTERN, null, msgs);
			}
			if (newStoryPattern != null)
			{
				msgs = ((InternalEObject) newStoryPattern).eInverseAdd(this, InternalEObject.EOPPOSITE_FEATURE_BASE
						- MlsdmPackage.STORY_NODE__STORY_PATTERN, null, msgs);
			}
			msgs = this.basicSetStoryPattern(newStoryPattern, msgs);
			if (msgs != null)
			{
				msgs.dispatch();
			}
		}
		else if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.STORY_NODE__STORY_PATTERN, newStoryPattern,
					newStoryPattern));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public StoryNodeSemanticsEnum getSemantics()
	{
		return this.semantics;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setSemantics(final StoryNodeSemanticsEnum newSemantics)
	{
		final StoryNodeSemanticsEnum oldSemantics = this.semantics;
		this.semantics = newSemantics == null ? StoryNodeImpl.SEMANTICS_EDEFAULT : newSemantics;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.STORY_NODE__SEMANTICS, oldSemantics, this.semantics));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.STORY_NODE__STORY_PATTERN:
				return this.basicSetStoryPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve, final boolean coreType)
	{
		switch (featureID)
		{
			case MlsdmPackage.STORY_NODE__NAME:
				return this.getName();
			case MlsdmPackage.STORY_NODE__STORY_PATTERN:
				return this.getStoryPattern();
			case MlsdmPackage.STORY_NODE__SEMANTICS:
				return this.getSemantics();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(final int featureID, final Object newValue)
	{
		switch (featureID)
		{
			case MlsdmPackage.STORY_NODE__NAME:
				this.setName((String) newValue);
				return;
			case MlsdmPackage.STORY_NODE__STORY_PATTERN:
				this.setStoryPattern((StoryPattern) newValue);
				return;
			case MlsdmPackage.STORY_NODE__SEMANTICS:
				this.setSemantics((StoryNodeSemanticsEnum) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.STORY_NODE__NAME:
				this.setName(StoryNodeImpl.NAME_EDEFAULT);
				return;
			case MlsdmPackage.STORY_NODE__STORY_PATTERN:
				this.setStoryPattern((StoryPattern) null);
				return;
			case MlsdmPackage.STORY_NODE__SEMANTICS:
				this.setSemantics(StoryNodeImpl.SEMANTICS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.STORY_NODE__NAME:
				return StoryNodeImpl.NAME_EDEFAULT == null ? this.name != null : !StoryNodeImpl.NAME_EDEFAULT.equals(this.name);
			case MlsdmPackage.STORY_NODE__STORY_PATTERN:
				return this.storyPattern != null;
			case MlsdmPackage.STORY_NODE__SEMANTICS:
				return this.semantics != StoryNodeImpl.SEMANTICS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(final int derivedFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLNamedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.STORY_NODE__NAME:
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(final int baseFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLNamedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_NAMED_ELEMENT__NAME:
					return MlsdmPackage.STORY_NODE__NAME;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString()
	{
		if (this.eIsProxy())
		{
			return super.toString();
		}

		final StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(this.name);
		result.append(", semantics: ");
		result.append(this.semantics);
		result.append(')');
		return result.toString();
	}

} // StoryNodeImpl
