/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.StructuredNode;
import de.mdelab.mlsdm.SynchronizationEdge;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Structured Node</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.impl.StructuredNodeImpl#getEdges <em>Edges</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.StructuredNodeImpl#getNodes <em>Nodes</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.StructuredNodeImpl#getSemaphores <em>
 * Semaphores</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.StructuredNodeImpl#getSynchronizationEdges
 * <em>Synchronization Edges</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class StructuredNodeImpl extends ActivityNodeImpl implements StructuredNode
{
	/**
	 * The cached value of the '{@link #getEdges() <em>Edges</em>}' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge>			edges;

	/**
	 * The cached value of the '{@link #getNodes() <em>Nodes</em>}' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getNodes()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityNode>			nodes;

	/**
	 * The cached value of the '{@link #getSemaphores() <em>Semaphores</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSemaphores()
	 * @generated
	 * @ordered
	 */
	protected EList<Semaphore>				semaphores;

	/**
	 * The cached value of the '{@link #getSynchronizationEdges()
	 * <em>Synchronization Edges</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSynchronizationEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<SynchronizationEdge>	synchronizationEdges;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected StructuredNodeImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return MlsdmPackage.Literals.STRUCTURED_NODE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ActivityEdge> getEdges()
	{
		if (this.edges == null)
		{
			this.edges = new EObjectContainmentWithInverseEList<ActivityEdge>(ActivityEdge.class, this,
					MlsdmPackage.STRUCTURED_NODE__EDGES, MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER);
		}
		return this.edges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ActivityNode> getNodes()
	{
		if (this.nodes == null)
		{
			this.nodes = new EObjectContainmentWithInverseEList<ActivityNode>(ActivityNode.class, this,
					MlsdmPackage.STRUCTURED_NODE__NODES, MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER);
		}
		return this.nodes;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<Semaphore> getSemaphores()
	{
		if (this.semaphores == null)
		{
			this.semaphores = new EObjectContainmentWithInverseEList<Semaphore>(Semaphore.class, this,
					MlsdmPackage.STRUCTURED_NODE__SEMAPHORES, MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER);
		}
		return this.semaphores;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<SynchronizationEdge> getSynchronizationEdges()
	{
		if (this.synchronizationEdges == null)
		{
			this.synchronizationEdges = new EObjectContainmentWithInverseEList<SynchronizationEdge>(SynchronizationEdge.class, this,
					MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES, MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER);
		}
		return this.synchronizationEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.STRUCTURED_NODE__EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getEdges()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.STRUCTURED_NODE__NODES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getNodes()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getSemaphores()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getSynchronizationEdges()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.STRUCTURED_NODE__EDGES:
				return ((InternalEList<?>) this.getEdges()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.STRUCTURED_NODE__NODES:
				return ((InternalEList<?>) this.getNodes()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
				return ((InternalEList<?>) this.getSemaphores()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
				return ((InternalEList<?>) this.getSynchronizationEdges()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve, final boolean coreType)
	{
		switch (featureID)
		{
			case MlsdmPackage.STRUCTURED_NODE__EDGES:
				return this.getEdges();
			case MlsdmPackage.STRUCTURED_NODE__NODES:
				return this.getNodes();
			case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
				return this.getSemaphores();
			case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
				return this.getSynchronizationEdges();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(final int featureID, final Object newValue)
	{
		switch (featureID)
		{
			case MlsdmPackage.STRUCTURED_NODE__EDGES:
				this.getEdges().clear();
				this.getEdges().addAll((Collection<? extends ActivityEdge>) newValue);
				return;
			case MlsdmPackage.STRUCTURED_NODE__NODES:
				this.getNodes().clear();
				this.getNodes().addAll((Collection<? extends ActivityNode>) newValue);
				return;
			case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
				this.getSemaphores().clear();
				this.getSemaphores().addAll((Collection<? extends Semaphore>) newValue);
				return;
			case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
				this.getSynchronizationEdges().clear();
				this.getSynchronizationEdges().addAll((Collection<? extends SynchronizationEdge>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.STRUCTURED_NODE__EDGES:
				this.getEdges().clear();
				return;
			case MlsdmPackage.STRUCTURED_NODE__NODES:
				this.getNodes().clear();
				return;
			case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
				this.getSemaphores().clear();
				return;
			case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
				this.getSynchronizationEdges().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.STRUCTURED_NODE__EDGES:
				return this.edges != null && !this.edges.isEmpty();
			case MlsdmPackage.STRUCTURED_NODE__NODES:
				return this.nodes != null && !this.nodes.isEmpty();
			case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
				return this.semaphores != null && !this.semaphores.isEmpty();
			case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
				return this.synchronizationEdges != null && !this.synchronizationEdges.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(final int derivedFeatureID, final Class<?> baseClass)
	{
		if (baseClass == ActivityNodeContainer.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.STRUCTURED_NODE__EDGES:
					return MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES;
				case MlsdmPackage.STRUCTURED_NODE__NODES:
					return MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES;
				case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
					return MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES;
				case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
					return MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(final int baseFeatureID, final Class<?> baseClass)
	{
		if (baseClass == ActivityNodeContainer.class)
		{
			switch (baseFeatureID)
			{
				case MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES:
					return MlsdmPackage.STRUCTURED_NODE__EDGES;
				case MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES:
					return MlsdmPackage.STRUCTURED_NODE__NODES;
				case MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES:
					return MlsdmPackage.STRUCTURED_NODE__SEMAPHORES;
				case MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES:
					return MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} // StructuredNodeImpl
