/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.SynchronizationEdge;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Synchronization Edge</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link de.mdelab.mlsdm.impl.SynchronizationEdgeImpl#getAnnotations <em>
 * Annotations</em>}</li>
 * <li>
 * {@link de.mdelab.mlsdm.impl.SynchronizationEdgeImpl#getActivityNodeContainer
 * <em>Activity Node Container</em>}</li>
 * <li>{@link de.mdelab.mlsdm.impl.SynchronizationEdgeImpl#getWeight <em>Weight
 * </em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class SynchronizationEdgeImpl extends MLElementWithUUIDImpl implements SynchronizationEdge
{
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation>	annotations;

	/**
	 * The default value of the '{@link #getWeight() <em>Weight</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getWeight()
	 * @generated
	 * @ordered
	 */
	protected static final int		WEIGHT_EDEFAULT	= 1;

	/**
	 * The cached value of the '{@link #getWeight() <em>Weight</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getWeight()
	 * @generated
	 * @ordered
	 */
	protected int					weight			= SynchronizationEdgeImpl.WEIGHT_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SynchronizationEdgeImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return MlsdmPackage.Literals.SYNCHRONIZATION_EDGE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations()
	{
		if (this.annotations == null)
		{
			this.annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(MLAnnotation.class, this,
					MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS, MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return this.annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityNodeContainer getActivityNodeContainer()
	{
		if (this.eContainerFeatureID() != MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER)
		{
			return null;
		}
		return (ActivityNodeContainer) this.eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetActivityNodeContainer(final ActivityNodeContainer newActivityNodeContainer, NotificationChain msgs)
	{
		msgs = this.eBasicSetContainer((InternalEObject) newActivityNodeContainer,
				MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setActivityNodeContainer(final ActivityNodeContainer newActivityNodeContainer)
	{
		if (newActivityNodeContainer != this.eInternalContainer()
				|| this.eContainerFeatureID() != MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER
				&& newActivityNodeContainer != null)
		{
			if (EcoreUtil.isAncestor(this, newActivityNodeContainer))
			{
				throw new IllegalArgumentException("Recursive containment not allowed for " + this.toString());
			}
			NotificationChain msgs = null;
			if (this.eInternalContainer() != null)
			{
				msgs = this.eBasicRemoveFromContainer(msgs);
			}
			if (newActivityNodeContainer != null)
			{
				msgs = ((InternalEObject) newActivityNodeContainer).eInverseAdd(this,
						MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES, ActivityNodeContainer.class, msgs);
			}
			msgs = this.basicSetActivityNodeContainer(newActivityNodeContainer, msgs);
			if (msgs != null)
			{
				msgs.dispatch();
			}
		}
		else if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER,
					newActivityNodeContainer, newActivityNodeContainer));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int getWeight()
	{
		return this.weight;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setWeight(final int newWeight)
	{
		final int oldWeight = this.weight;
		this.weight = newWeight;
		if (this.eNotificationRequired())
		{
			this.eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.SYNCHRONIZATION_EDGE__WEIGHT, oldWeight, this.weight));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(final InternalEObject otherEnd, final int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) this.getAnnotations()).basicAdd(otherEnd, msgs);
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER:
				if (this.eInternalContainer() != null)
				{
					msgs = this.eBasicRemoveFromContainer(msgs);
				}
				return this.basicSetActivityNodeContainer((ActivityNodeContainer) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd, final int featureID, final NotificationChain msgs)
	{
		switch (featureID)
		{
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS:
				return ((InternalEList<?>) this.getAnnotations()).basicRemove(otherEnd, msgs);
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER:
				return this.basicSetActivityNodeContainer(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(final NotificationChain msgs)
	{
		switch (this.eContainerFeatureID())
		{
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER:
				return this.eInternalContainer().eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES,
						ActivityNodeContainer.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve, final boolean coreType)
	{
		switch (featureID)
		{
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS:
				return this.getAnnotations();
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER:
				return this.getActivityNodeContainer();
			case MlsdmPackage.SYNCHRONIZATION_EDGE__WEIGHT:
				return this.getWeight();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(final int featureID, final Object newValue)
	{
		switch (featureID)
		{
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS:
				this.getAnnotations().clear();
				this.getAnnotations().addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER:
				this.setActivityNodeContainer((ActivityNodeContainer) newValue);
				return;
			case MlsdmPackage.SYNCHRONIZATION_EDGE__WEIGHT:
				this.setWeight((Integer) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS:
				this.getAnnotations().clear();
				return;
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER:
				this.setActivityNodeContainer((ActivityNodeContainer) null);
				return;
			case MlsdmPackage.SYNCHRONIZATION_EDGE__WEIGHT:
				this.setWeight(SynchronizationEdgeImpl.WEIGHT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID)
	{
		switch (featureID)
		{
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS:
				return this.annotations != null && !this.annotations.isEmpty();
			case MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER:
				return this.getActivityNodeContainer() != null;
			case MlsdmPackage.SYNCHRONIZATION_EDGE__WEIGHT:
				return this.weight != SynchronizationEdgeImpl.WEIGHT_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(final int derivedFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (derivedFeatureID)
			{
				case MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS:
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(final int baseFeatureID, final Class<?> baseClass)
	{
		if (baseClass == MLAnnotatedElement.class)
		{
			switch (baseFeatureID)
			{
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
					return MlsdmPackage.SYNCHRONIZATION_EDGE__ANNOTATIONS;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString()
	{
		if (this.eIsProxy())
		{
			return super.toString();
		}

		final StringBuffer result = new StringBuffer(super.toString());
		result.append(" (weight: ");
		result.append(this.weight);
		result.append(')');
		return result.toString();
	}

} // SynchronizationEdgeImpl
