/**
 */
package de.mdelab.mlsdm.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.mlsdm.FlowFinalNode;
import de.mdelab.mlsdm.ForkJoinNode;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.OutputParameterValue;
import de.mdelab.mlsdm.ReleaseEdge;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StructuredNode;
import de.mdelab.mlsdm.SynchronizationEdge;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides
 * an adapter <code>createXXX</code> method for each class of the model. <!--
 * end-user-doc -->
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage
 * @generated
 */
public class MlsdmAdapterFactory extends AdapterFactoryImpl
{
	/**
	 * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static MlsdmPackage	modelPackage;

	/**
	 * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public MlsdmAdapterFactory()
	{
		if (MlsdmAdapterFactory.modelPackage == null)
		{
			MlsdmAdapterFactory.modelPackage = MlsdmPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code> if
	 * the object is either the model's package or is an instance object of the
	 * model. <!-- end-user-doc -->
	 * 
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(final Object object)
	{
		if (object == MlsdmAdapterFactory.modelPackage)
		{
			return true;
		}
		if (object instanceof EObject)
		{
			return ((EObject) object).eClass().getEPackage() == MlsdmAdapterFactory.modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected MlsdmSwitch<Adapter>	modelSwitch	= new MlsdmSwitch<Adapter>()
												{
													@Override
													public Adapter caseActivityNodeContainer(final ActivityNodeContainer object)
													{
														return MlsdmAdapterFactory.this.createActivityNodeContainerAdapter();
													}

													@Override
													public Adapter caseActivity(final Activity object)
													{
														return MlsdmAdapterFactory.this.createActivityAdapter();
													}

													@Override
													public Adapter caseActivityNode(final ActivityNode object)
													{
														return MlsdmAdapterFactory.this.createActivityNodeAdapter();
													}

													@Override
													public Adapter caseActivityEdge(final ActivityEdge object)
													{
														return MlsdmAdapterFactory.this.createActivityEdgeAdapter();
													}

													@Override
													public Adapter caseInitialNode(final InitialNode object)
													{
														return MlsdmAdapterFactory.this.createInitialNodeAdapter();
													}

													@Override
													public Adapter caseFlowFinalNode(final FlowFinalNode object)
													{
														return MlsdmAdapterFactory.this.createFlowFinalNodeAdapter();
													}

													@Override
													public Adapter caseActivityFinalNode(final ActivityFinalNode object)
													{
														return MlsdmAdapterFactory.this.createActivityFinalNodeAdapter();
													}

													@Override
													public Adapter caseExpressionActivityNode(final ExpressionActivityNode object)
													{
														return MlsdmAdapterFactory.this.createExpressionActivityNodeAdapter();
													}

													@Override
													public Adapter caseDecisionMergeNode(final DecisionMergeNode object)
													{
														return MlsdmAdapterFactory.this.createDecisionMergeNodeAdapter();
													}

													@Override
													public Adapter caseForkJoinNode(final ForkJoinNode object)
													{
														return MlsdmAdapterFactory.this.createForkJoinNodeAdapter();
													}

													@Override
													public Adapter caseStoryNode(final StoryNode object)
													{
														return MlsdmAdapterFactory.this.createStoryNodeAdapter();
													}

													@Override
													public Adapter caseStructuredNode(final StructuredNode object)
													{
														return MlsdmAdapterFactory.this.createStructuredNodeAdapter();
													}

													@Override
													public Adapter caseSemaphore(final Semaphore object)
													{
														return MlsdmAdapterFactory.this.createSemaphoreAdapter();
													}

													@Override
													public Adapter caseSynchronizationEdge(final SynchronizationEdge object)
													{
														return MlsdmAdapterFactory.this.createSynchronizationEdgeAdapter();
													}

													@Override
													public Adapter caseAcquireEdge(final AcquireEdge object)
													{
														return MlsdmAdapterFactory.this.createAcquireEdgeAdapter();
													}

													@Override
													public Adapter caseReleaseEdge(final ReleaseEdge object)
													{
														return MlsdmAdapterFactory.this.createReleaseEdgeAdapter();
													}

													@Override
													public Adapter caseActivityParameter(final ActivityParameter object)
													{
														return MlsdmAdapterFactory.this.createActivityParameterAdapter();
													}

													@Override
													public Adapter caseOutputParameterValue(final OutputParameterValue object)
													{
														return MlsdmAdapterFactory.this.createOutputParameterValueAdapter();
													}

													@Override
													public Adapter caseMLElementWithUUID(final MLElementWithUUID object)
													{
														return MlsdmAdapterFactory.this.createMLElementWithUUIDAdapter();
													}

													@Override
													public Adapter caseMLAnnotatedElement(final MLAnnotatedElement object)
													{
														return MlsdmAdapterFactory.this.createMLAnnotatedElementAdapter();
													}

													@Override
													public Adapter caseMLNamedElement(final MLNamedElement object)
													{
														return MlsdmAdapterFactory.this.createMLNamedElementAdapter();
													}

													@Override
													public Adapter caseMLTypedElement(final MLTypedElement object)
													{
														return MlsdmAdapterFactory.this.createMLTypedElementAdapter();
													}

													@Override
													public Adapter defaultCase(final EObject object)
													{
														return MlsdmAdapterFactory.this.createEObjectAdapter();
													}
												};

	/**
	 * Creates an adapter for the <code>target</code>. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param target
	 *            the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(final Notifier target)
	{
		return this.modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.ActivityNodeContainer
	 * <em>Activity Node Container</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer
	 * @generated
	 */
	public Adapter createActivityNodeContainerAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.Activity <em>Activity</em>}'. <!-- begin-user-doc
	 * --> This default implementation returns null so that we can easily ignore
	 * cases; it's useful to ignore a case when inheritance will catch all the
	 * cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.Activity
	 * @generated
	 */
	public Adapter createActivityAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.ActivityNode <em>Activity Node</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.ActivityNode
	 * @generated
	 */
	public Adapter createActivityNodeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.ActivityEdge <em>Activity Edge</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.ActivityEdge
	 * @generated
	 */
	public Adapter createActivityEdgeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.InitialNode <em>Initial Node</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.InitialNode
	 * @generated
	 */
	public Adapter createInitialNodeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.FlowFinalNode <em>Flow Final Node</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.FlowFinalNode
	 * @generated
	 */
	public Adapter createFlowFinalNodeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.ActivityFinalNode <em>Activity Final Node</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.ActivityFinalNode
	 * @generated
	 */
	public Adapter createActivityFinalNodeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.ExpressionActivityNode
	 * <em>Expression Activity Node</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.ExpressionActivityNode
	 * @generated
	 */
	public Adapter createExpressionActivityNodeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.DecisionMergeNode <em>Decision Merge Node</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.DecisionMergeNode
	 * @generated
	 */
	public Adapter createDecisionMergeNodeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.ForkJoinNode <em>Fork Join Node</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.ForkJoinNode
	 * @generated
	 */
	public Adapter createForkJoinNodeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.StoryNode <em>Story Node</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.StoryNode
	 * @generated
	 */
	public Adapter createStoryNodeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.StructuredNode <em>Structured Node</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.StructuredNode
	 * @generated
	 */
	public Adapter createStructuredNodeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.Semaphore <em>Semaphore</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.Semaphore
	 * @generated
	 */
	public Adapter createSemaphoreAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.SynchronizationEdge <em>Synchronization Edge</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so
	 * that we can easily ignore cases; it's useful to ignore a case when
	 * inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.SynchronizationEdge
	 * @generated
	 */
	public Adapter createSynchronizationEdgeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.AcquireEdge <em>Acquire Edge</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.AcquireEdge
	 * @generated
	 */
	public Adapter createAcquireEdgeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.ReleaseEdge <em>Release Edge</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.ReleaseEdge
	 * @generated
	 */
	public Adapter createReleaseEdgeAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.ActivityParameter <em>Activity Parameter</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.ActivityParameter
	 * @generated
	 */
	public Adapter createActivityParameterAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlsdm.OutputParameterValue
	 * <em>Output Parameter Value</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.OutputParameterValue
	 * @generated
	 */
	public Adapter createOutputParameterValueAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlcore.MLAnnotatedElement <em>ML Annotated Element</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so
	 * that we can easily ignore cases; it's useful to ignore a case when
	 * inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlcore.MLAnnotatedElement
	 * @generated
	 */
	public Adapter createMLAnnotatedElementAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlcore.MLElementWithUUID <em>ML Element With UUID</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so
	 * that we can easily ignore cases; it's useful to ignore a case when
	 * inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlcore.MLElementWithUUID
	 * @generated
	 */
	public Adapter createMLElementWithUUIDAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlcore.MLNamedElement <em>ML Named Element</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlcore.MLNamedElement
	 * @generated
	 */
	public Adapter createMLNamedElementAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlcore.MLTypedElement <em>ML Typed Element</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlcore.MLTypedElement
	 * @generated
	 */
	public Adapter createMLTypedElementAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for the default case. <!-- begin-user-doc --> This
	 * default implementation returns null. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter()
	{
		return null;
	}

} // MlsdmAdapterFactory
