/**
 */
package de.mdelab.mlsdm.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.mlsdm.FlowFinalNode;
import de.mdelab.mlsdm.ForkJoinNode;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.OutputParameterValue;
import de.mdelab.mlsdm.ReleaseEdge;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StructuredNode;
import de.mdelab.mlsdm.SynchronizationEdge;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * 
 * @see de.mdelab.mlsdm.MlsdmPackage
 * @generated
 */
public class MlsdmSwitch<T> extends Switch<T>
{
	/**
	 * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static MlsdmPackage	modelPackage;

	/**
	 * Creates an instance of the switch. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public MlsdmSwitch()
	{
		if (MlsdmSwitch.modelPackage == null)
		{
			MlsdmSwitch.modelPackage = MlsdmPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(final EPackage ePackage)
	{
		return ePackage == MlsdmSwitch.modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns
	 * a non null result; it yields that result. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	@Override
	protected T doSwitch(final int classifierID, final EObject theEObject)
	{
		switch (classifierID)
		{
			case MlsdmPackage.ACTIVITY_NODE_CONTAINER:
			{
				final ActivityNodeContainer activityNodeContainer = (ActivityNodeContainer) theEObject;
				T result = this.caseActivityNodeContainer(activityNodeContainer);
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.ACTIVITY:
			{
				final Activity activity = (Activity) theEObject;
				T result = this.caseActivity(activity);
				if (result == null)
				{
					result = this.caseMLElementWithUUID(activity);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(activity);
				}
				if (result == null)
				{
					result = this.caseMLNamedElement(activity);
				}
				if (result == null)
				{
					result = this.caseActivityNodeContainer(activity);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.ACTIVITY_NODE:
			{
				final ActivityNode activityNode = (ActivityNode) theEObject;
				T result = this.caseActivityNode(activityNode);
				if (result == null)
				{
					result = this.caseMLElementWithUUID(activityNode);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(activityNode);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.ACTIVITY_EDGE:
			{
				final ActivityEdge activityEdge = (ActivityEdge) theEObject;
				T result = this.caseActivityEdge(activityEdge);
				if (result == null)
				{
					result = this.caseMLElementWithUUID(activityEdge);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(activityEdge);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.INITIAL_NODE:
			{
				final InitialNode initialNode = (InitialNode) theEObject;
				T result = this.caseInitialNode(initialNode);
				if (result == null)
				{
					result = this.caseActivityNode(initialNode);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(initialNode);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(initialNode);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.FLOW_FINAL_NODE:
			{
				final FlowFinalNode flowFinalNode = (FlowFinalNode) theEObject;
				T result = this.caseFlowFinalNode(flowFinalNode);
				if (result == null)
				{
					result = this.caseActivityNode(flowFinalNode);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(flowFinalNode);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(flowFinalNode);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.ACTIVITY_FINAL_NODE:
			{
				final ActivityFinalNode activityFinalNode = (ActivityFinalNode) theEObject;
				T result = this.caseActivityFinalNode(activityFinalNode);
				if (result == null)
				{
					result = this.caseActivityNode(activityFinalNode);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(activityFinalNode);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(activityFinalNode);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE:
			{
				final ExpressionActivityNode expressionActivityNode = (ExpressionActivityNode) theEObject;
				T result = this.caseExpressionActivityNode(expressionActivityNode);
				if (result == null)
				{
					result = this.caseActivityNode(expressionActivityNode);
				}
				if (result == null)
				{
					result = this.caseMLNamedElement(expressionActivityNode);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(expressionActivityNode);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(expressionActivityNode);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.DECISION_MERGE_NODE:
			{
				final DecisionMergeNode decisionMergeNode = (DecisionMergeNode) theEObject;
				T result = this.caseDecisionMergeNode(decisionMergeNode);
				if (result == null)
				{
					result = this.caseActivityNode(decisionMergeNode);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(decisionMergeNode);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(decisionMergeNode);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.FORK_JOIN_NODE:
			{
				final ForkJoinNode forkJoinNode = (ForkJoinNode) theEObject;
				T result = this.caseForkJoinNode(forkJoinNode);
				if (result == null)
				{
					result = this.caseActivityNode(forkJoinNode);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(forkJoinNode);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(forkJoinNode);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.STORY_NODE:
			{
				final StoryNode storyNode = (StoryNode) theEObject;
				T result = this.caseStoryNode(storyNode);
				if (result == null)
				{
					result = this.caseActivityNode(storyNode);
				}
				if (result == null)
				{
					result = this.caseMLNamedElement(storyNode);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(storyNode);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(storyNode);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.STRUCTURED_NODE:
			{
				final StructuredNode structuredNode = (StructuredNode) theEObject;
				T result = this.caseStructuredNode(structuredNode);
				if (result == null)
				{
					result = this.caseActivityNode(structuredNode);
				}
				if (result == null)
				{
					result = this.caseActivityNodeContainer(structuredNode);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(structuredNode);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(structuredNode);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.SEMAPHORE:
			{
				final Semaphore semaphore = (Semaphore) theEObject;
				T result = this.caseSemaphore(semaphore);
				if (result == null)
				{
					result = this.caseMLElementWithUUID(semaphore);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(semaphore);
				}
				if (result == null)
				{
					result = this.caseMLNamedElement(semaphore);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.SYNCHRONIZATION_EDGE:
			{
				final SynchronizationEdge synchronizationEdge = (SynchronizationEdge) theEObject;
				T result = this.caseSynchronizationEdge(synchronizationEdge);
				if (result == null)
				{
					result = this.caseMLElementWithUUID(synchronizationEdge);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(synchronizationEdge);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.ACQUIRE_EDGE:
			{
				final AcquireEdge acquireEdge = (AcquireEdge) theEObject;
				T result = this.caseAcquireEdge(acquireEdge);
				if (result == null)
				{
					result = this.caseSynchronizationEdge(acquireEdge);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(acquireEdge);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(acquireEdge);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.RELEASE_EDGE:
			{
				final ReleaseEdge releaseEdge = (ReleaseEdge) theEObject;
				T result = this.caseReleaseEdge(releaseEdge);
				if (result == null)
				{
					result = this.caseSynchronizationEdge(releaseEdge);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(releaseEdge);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(releaseEdge);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.ACTIVITY_PARAMETER:
			{
				final ActivityParameter activityParameter = (ActivityParameter) theEObject;
				T result = this.caseActivityParameter(activityParameter);
				if (result == null)
				{
					result = this.caseMLElementWithUUID(activityParameter);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(activityParameter);
				}
				if (result == null)
				{
					result = this.caseMLNamedElement(activityParameter);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(activityParameter);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlsdmPackage.OUTPUT_PARAMETER_VALUE:
			{
				final OutputParameterValue outputParameterValue = (OutputParameterValue) theEObject;
				T result = this.caseOutputParameterValue(outputParameterValue);
				if (result == null)
				{
					result = this.caseMLElementWithUUID(outputParameterValue);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(outputParameterValue);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			default:
				return this.defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Activity Node Container</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Activity Node Container</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityNodeContainer(final ActivityNodeContainer object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Activity</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Activity</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivity(final Activity object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Activity Node</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Activity Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityNode(final ActivityNode object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Activity Edge</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Activity Edge</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityEdge(final ActivityEdge object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Initial Node</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Initial Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInitialNode(final InitialNode object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Flow Final Node</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Flow Final Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFlowFinalNode(final FlowFinalNode object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Activity Final Node</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Activity Final Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityFinalNode(final ActivityFinalNode object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Expression Activity Node</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Expression Activity Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseExpressionActivityNode(final ExpressionActivityNode object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Decision Merge Node</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Decision Merge Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDecisionMergeNode(final DecisionMergeNode object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Fork Join Node</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Fork Join Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseForkJoinNode(final ForkJoinNode object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Story Node</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Story Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStoryNode(final StoryNode object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Structured Node</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Structured Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStructuredNode(final StructuredNode object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Semaphore</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Semaphore</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSemaphore(final Semaphore object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Synchronization Edge</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Synchronization Edge</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSynchronizationEdge(final SynchronizationEdge object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Acquire Edge</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Acquire Edge</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAcquireEdge(final AcquireEdge object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Release Edge</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Release Edge</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseReleaseEdge(final ReleaseEdge object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Activity Parameter</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Activity Parameter</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityParameter(final ActivityParameter object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Output Parameter Value</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Output Parameter Value</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOutputParameterValue(final OutputParameterValue object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ML Annotated Element</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ML Annotated Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLAnnotatedElement(final MLAnnotatedElement object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ML Element With UUID</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ML Element With UUID</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLElementWithUUID(final MLElementWithUUID object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ML Named Element</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ML Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLNamedElement(final MLNamedElement object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ML Typed Element</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ML Typed Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLTypedElement(final MLTypedElement object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>EObject</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(final EObject object)
	{
		return null;
	}

} // MlsdmSwitch
